#-*- coding:utf-8 -*-
# ----------------------------------------------
# Antenna A Serial Port
# ----------------------------------------------
import serial
from System import *
from Antenna import *
from NMEA import *
from Communicator import *

class AntennaSubCommunicator(Communicator):
    def __init__(self,name):
        Communicator.__init__(self,name)
        self.Ant = Antenna('Antenna')
        self.Nmea = NmeaFormatter()
        self.DevName = ''
        Communicator.ResetFlag(self)
        self.TxArr = []
        p = Thread(target=self.TxWorker)
        p.start()
    def Open(self,name,baudrate):
        self.out("Opend %s-%s"%(name,baudrate))
        self.DevName = name
        self.Comm = serial.Serial(name, baudrate)
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.Comm.close()
    def Start(self):
        line = ""
        while True:
            ch  = self.Comm.read(1)
            line += ch    
            if ch == '\n':
				self.DatProc(line)
				line = ""	
    def DatProc(self,line):
        # self.out(line)
        if len(line) < 5 : return 
        if line[0:2] == '$K' : 
            lines = line.split(',')
            if len(lines) > 3 : 
				# self.out(line)
				if lines[2] == 'STS' : self.Ant.DatProc(line)
				elif lines[2] == 'GPS' : self.Ant.Nmea.BurstGpsProc(line)
            self.SetFlag() 
        elif line[0:2] == '$G' : 
            self.out(line)
            self.Nmea.DatProc(line)
    def Send(self,dat):
        self.TxArr.append(dat)
    def TxWorker(self):
        time.sleep(2)
        while True:
            time.sleep(0.05)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                # self.out("len {}  {}".format(len(self.TxArr),dat ))
                try:
                    lines = dat.split(',')
                    if lines[1] == "DAT_O" : self.out(dat)
                    elif lines[1] == "DAT_P" : self.out(dat)
                    self.Comm.write(dat)
                except: self.out('Transfer Error - Antenna AntennaSubCommunicator')
                



