#-*- coding:utf-8 -*-
import time
import sys, termios, struct, fcntl
from threading import Thread

if (sys.hexversion < 0x020100f0): import TERMIOS
else: TERMIOS = termios
if (sys.hexversion < 0x020200f0): import FCNTL
else: FCNTL = fcntl
TIOCMBIS  = hasattr(TERMIOS, 'TIOCMBIS') and TERMIOS.TIOCMBIS or 0x5416
TIOCMBIC  = hasattr(TERMIOS, 'TIOCMBIC') and TERMIOS.TIOCMBIC or 0x5417
TIOCM_DTR = hasattr(TERMIOS, 'TIOCM_DTR') and TERMIOS.TIOCM_DTR or 0x002
TIOCM_RTS = hasattr(TERMIOS, 'TIOCM_RTS') and TERMIOS.TIOCM_RTS or 0x004
TIOCM_RTS_str = struct.pack('I', TIOCM_RTS)
TIOCM_DTR_str = struct.pack('I', TIOCM_DTR)

class BlockControl:
    def __init__(self):
        self.IsBlock = True
        self.Track = 0
        self.Count = 0
        p = Thread(target=self.Worker)
        p.start()
    def Worker(self):
		from Project import pj 
		time.sleep(2)
		while True:
			time.sleep(0.1)
            # Check Connection about NMEA
			if pj.SelectedAnt != None :    
				self.Track = (1 if int(pj.SelectedAnt.Status.GetWithToken('TrackingStatus')) == 1 else 0)
				if self.Track == 1 :
					if self.Count < 100 : self.Count += 1 
				else : self.Count = 0   
				if self.Count > 5 : 
					self.IsBlock = False
					fcntl.ioctl(pj.ConComm.Comm, TIOCMBIS, TIOCM_DTR_str)
				else : 
					self.IsBlock = True
					fcntl.ioctl(pj.ConComm.Comm, TIOCMBIC, TIOCM_DTR_str)
			else : 
				self.Count = 0
				self.Track = 0
				self.IsBlock = True
                
    def GetArray(self):
        from Project import pj 
        dat = { 
            'IsBlock': self.IsBlock,
            'Track': self.Track,
            'Count': self.Count
        }
        return dat
