#-*- coding:utf-8 -*-               
import serial
import time
import sys, termios, struct, fcntl
from NMEA import *
from Communicator import *
from threading import Thread

 



class ConsoleCommunicator(Communicator): 
    def __init__(self,name):
        Communicator.__init__(self,name)
        self.TxArr = []
        self.Nmea = NmeaFormatter()
        self.DevName = ''
        Communicator.ResetFlag(self)
        self.SubExtNmea = Communicator("SubExtNmea")
        self.SubExtNmea.ResetFlag()
        
        p = Thread(target=self.TxWorker)
        p.start()
    def Open(self,name,baudrate):
        self.out("Opend %s-%s"%(name,baudrate))
        self.DevName = name
        self.Comm = serial.Serial(name, baudrate)
        
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.Comm.close()
    def getCD(self):
        if (sys.hexversion < 0x020100f0): import TERMIOS
        else: TERMIOS = termios
        if (sys.hexversion < 0x020200f0): import FCNTL
        else: FCNTL = fcntl
        TIOCM_zero_str = struct.pack('I', 0)
        TIOCMGET  = hasattr(TERMIOS, 'TIOCMGET') and TERMIOS.TIOCMGET or 0x5415
        TIOCM_CD  = hasattr(TERMIOS, 'TIOCM_CD') and TERMIOS.TIOCM_CD or TIOCM_CAR
        s = fcntl.ioctl(self.Comm, TIOCMGET, TIOCM_zero_str)
        return struct.unpack('I',s)[0] & TIOCM_CD != 0
    def Start(self):
        line = ""
        while True: 
            ch  = self.Comm.read(1)
            line += ch          
            if ch == '\n':
				self.DatProc(line)
				line = ""	
    def DatProc(self,line):
        self.out(line)
        if len(line) < 5 : return 
        if line[0:2] == '$G' :
            self.out(line)
            self.SubExtNmea.SetFlag()
            self.Nmea.DatProc(line)
    def Send(self,dat):
        tmp = str(dat)
        tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def TxWorker(self):
        time.sleep(5)
        while True:
            time.sleep(0.1)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                self.Comm.write(dat.encode())
                # self.out(dat)
            # time.sleep(1)
            # dat = "$GPRMC,092750.000,A,5321.6802,N,00630.3372,W,0.02,31.66,280511,,,A*43\r\n"
            # if len(self.TxArr) > 0 : 
                # dat = self.TxArr.pop(0)
                # self.Comm.write(dat.encode())