#-*- coding:utf-8 -*-
import time
import pynmea2
from NMEA import *
from Util import *
from threading import Thread



class GpsManager:
    def __init__(self):
        self.OutNmea = ""
        self.OutConsole = ""
        self.UseRmcIdx = 0
        self.UseGgaIdx = 0
        self.UseGllIdx = 0
        self.StrRmc = None
        self.StrGga = None
        self.StrGll = None
        self.Lat = 0.0
        self.Lon = 0.0
        self.Valid = 0
        self.UTC = 0.0
        p = Thread(target=self.Worker)
        p.start()
    def Worker(self):
		from Project import pj 
		time.sleep(2)
		while True:
			time.sleep(1)
			rmc = None
			gga = None
            # Check Connection about NMEA
			if pj.GyroComm.SubExtNmea.IsConnect() == 1 and pj.GyroComm.Nmea.IsValidRmc() : 
				rmc = pj.GyroComm.Nmea.Rmc  
				self.UseRmcIdx = 1
			elif pj.NmeaComm.SubExtNmea.IsConnect() == 1 and pj.NmeaComm.Nmea.IsValidRmc() : 
				rmc = pj.NmeaComm.Nmea.Rmc  
				self.UseRmcIdx = 2
			elif pj.ConComm.SubExtNmea.IsConnect() == 1 and pj.ConComm.Nmea.IsValidRmc() : 
				rmc = pj.ConComm.Nmea.Rmc  
				self.UseRmcIdx = 3
			elif (pj.AntAInterface > 0) and pj.AntA.Nmea.IsValidRmc() : 
				rmc = pj.AntA.Nmea.Rmc  
				self.UseRmcIdx = 4
			elif (pj.AntBInterface > 0) and pj.AntB.Nmea.IsValidRmc() : 
				rmc = pj.AntB.Nmea.Rmc  
				self.UseRmcIdx = 5
                
			if pj.GyroComm.SubExtNmea.IsConnect() == 1 and pj.GyroComm.Nmea.IsValidGga() : 
				gga = pj.GyroComm.Nmea.Gga  
				self.UseGgaIdx = 1
			elif pj.NmeaComm.SubExtNmea.IsConnect() == 1 and pj.NmeaComm.Nmea.IsValidGga() : 
				gga = pj.NmeaComm.Nmea.Gga  
				self.UseGgaIdx = 2
			elif pj.ConComm.SubExtNmea.IsConnect() == 1 and pj.ConComm.Nmea.IsValidGga() : 
				gga = pj.ConComm.Nmea.Gga  
				self.UseGgaIdx = 3
			elif (pj.AntAInterface > 0) and pj.AntA.Nmea.IsValidGga() : 
				gga = pj.AntA.Nmea.Gga  
				self.UseGgaIdx = 4
			elif (pj.AntBInterface > 0) and pj.AntB.Nmea.IsValidGga() : 
				gga = pj.AntB.Nmea.Gga  
				self.UseGgaIdx = 5
                
             
			self.StrRmc = None
			self.StrGga = None
			self.StrGll = None

            # Contiune if unconnnted    
			if rmc != None : 
				self.StrGll = rmc.Gll.GetGpgll()
				self.StrRmc = rmc.GetGprmc(); 
				self.UseGllIdx = self.UseRmcIdx
               
			if gga != None : 
				self.StrGll = gga.Gll.GetGpgll()
				self.StrGga = gga.GetGpgga();  
				self.UseGllIdx = self.UseGgaIdx
                
                
            # Output gps data  
            # 1. Nmea Port  
			self.OutNmea=''
			if pj.Sys.GetNmeaFormat() == 1 : self.OutNmea = self.StrGga 
			elif pj.Sys.GetNmeaFormat() == 2 : self.OutNmea = self.StrGll
			else : self.OutNmea = self.StrRmc
            # 2. Console Port  
			self.OutConsole=''
			if pj.Sys.GetConsoleFormat() == 1 : self.OutConsole = self.StrGga 
			elif pj.Sys.GetConsoleFormat() == 2 : self.OutConsole = self.StrGll
			else : self.OutConsole = self.StrRmc
            
			# print pj.Sys.GetNmeaFormat() 
            
			# print self.OutNmea 
			# print self.OutConsole 
            
			if rmc != None and self.UseGgaIdx  <= self.UseRmcIdx  : 
				self.Lat = rmc.GetLatitude()
				self.Lon = rmc.GetLongitude()
				self.Valid = 1
				self.UTC = rmc.GetUTC()
			elif gga != None and self.UseGgaIdx  > self.UseRmcIdx  : 
				self.Lat = gga.GetLatitude()
				self.Lon = gga.GetLongitude()
				self.Valid = 1
				self.UTC = gga.GetUTC()
			elif (pj.AntAInterface > 0): 
				self.Valid = pj.AntA.GetGpsValid()
				self.Lat = pj.AntA.GetLatitude()
				self.Lon = pj.AntA.GetLongitude()
				self.UTC = Util.UTC()
				self.UseGgaIdx = 6
			elif (pj.AntBInterface > 0): 
				self.Valid = pj.AntB.GetGpsValid()
				self.Lat = pj.AntB.GetLatitude()
				self.Lon = pj.AntB.GetLongitude()
				self.UTC = Util.UTC()
				self.UseGgaIdx = 7
			else : 
				self.Valid = 0

			if self.OutNmea != None : pj.NmeaComm.Send(self.OutNmea)
			if self.OutConsole != None : pj.ConComm.Send(self.OutConsole)
    def GetArray(self):
        dat = { 
            'UseRmcIdx': self.UseRmcIdx,
            'UseGgaIdx': self.UseGgaIdx,
            'UseGllIdx': self.UseGllIdx,
            'Rmc': str(self.StrRmc),
            'Gga': str(self.StrGga),
            'Gll': str(self.StrGll),
            'Valid': self.Valid,
            'UTC': str(round(float(self.UTC),2)),
            'Lat': str(round(float(self.Lat),2)),
            'Lon': str(round(float(self.Lon),2)),
        }
        return dat
