import serial
import time
import pynmea2
from NMEA import *
from Communicator import *
from threading import Thread
from NMEA import GetHdtFormat


class GyroCommunicator(Communicator): 
    def __init__(self,name):
        Communicator.__init__(self,name)
        self.TxArr = []
        self.TxArrCustom = []
        self.Nmea = NmeaFormatter()
        self.DevName = ''
        self.RxCnt = 0
        Communicator.ResetFlag(self)
        self.SubExtNmea = Communicator("SubExtNmea")
        self.SubExtNmea.ResetFlag()
        self.SubExtGyro = Communicator("SubExtGyro")
        self.SubExtGyro.ResetFlag()
        p = Thread(target=self.TxWorker)
        p.start()
    def Open(self,name,baudrate):
        self.out("Opend %s-%s"%(name,baudrate))
        self.DevName = name
        self.Comm = serial.Serial(name, baudrate)
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.Comm.close()
    def Start(self):
        from Project import pj
        line = ""
        while True: 
            ch  = self.Comm.read(1)
            line += ch          
            if ch == '\n':
				if not pj.GyroReady : continue
				self.DatProc(line)
				line = ""	
    def DatProc(self,line):
        # self.out(line)
        if len(line) < 5 : return 
        elif line[0:2] == '$G' or line[0:2] == '$H' : 
            # self.out(line)
            self.SubExtNmea.SetFlag()
            self.Nmea.DatProc(line)
        if line[3] == 'H': self.SubExtGyro.SetFlag()
    def Send(self,dat):
        tmp = str(dat)
        tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def SendCustom(self,dat):
        tmp = str(dat)
        tmp = tmp + '\r\n'
        self.TxArrCustom.append(tmp)
    def SendForCustom(self,_dir,_sync,_type,_heading):
        tmp_dir = 1 if _dir == 0 else 5
        tmp_sync = 0 if _sync == 0 else 4
        tmp = "$PZSET,S,{}{}1{}*".format(tmp_dir,tmp_sync,_type)
        self.out("1) Custom(Sync,Step) Setting: "+ tmp) 
        self.SendCustom(tmp);
        
        tmp = GetHdtFormat(_heading)
        self.out("2) Send to heading(converter) : "+ tmp) 
        self.SendCustom(tmp);
        
        # self.Comm.write(tmp + '\r\n')
        # ** Example
        # sprintf(buf,"$PZSET,S,");
        # if(dir==GRDIRNOR)	strcat(buf,"1");
        # else			strcat(buf,"5");
        # if(freq==GYFRE50)	strcat(buf,"0");
        # else			strcat(buf,"4");
        # if(type==1)		strcat(buf,"10*\r\n");
        # else if(type==2) 	strcat(buf,"11*\r\n");
        # else if(type==3) 	strcat(buf,"12*\r\n");
        # else if(type==4) 	strcat(buf,"13*\r\n");
        # else if(type==5) 	strcat(buf,"14*\r\n");
        # else if(type==6) 	strcat(buf,"15*\r\n");
        # else if(type==7) 	strcat(buf,"16*\r\n");
        # else if(type==8) 	strcat(buf,"17*\r\n");
        # else				strcat(buf,"10*\r\n");
    
    def TxWorker(self):
        from Project import pj 
        time.sleep(5)
        while True:
            time.sleep(0.1)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                self.Comm.write(dat.encode())
            elif len(self.TxArrCustom) > 0 and pj.GyroSwitch == 1: 
                dat = self.TxArrCustom.pop(0)
                self.Comm.write(dat.encode())
                 