#-*- coding:utf-8 -*-
import time
import pynmea2
from threading import Thread

class GyroManager:
    def __init__(self):
        self.Actived = False
        self.UseIdx = 0
        self.Heading = 0.0
        self.Valid = 0
        self.UserValid = 0
        self.OutConsole = ""
        self.Type = 0
        
        self.ExtIdx = 0
        self.ExtHeading = 0.0
        self.ExtValid = 0
        p = Thread(target=self.Worker)
        p.start()
    def Worker(self):
		from Project import pj 
		time.sleep(2)
		self.UseIdx = 0
		self.Valid = 0
		while True:
			time.sleep(0.1)
        
            # Check Connection about NMEA
			gyro_type = int(pj.Sys.GetGyroType())
			self.Type = gyro_type
			if gyro_type == 0 :    
				self.Heading = pj.McuComm.Mcu.Heading
				self.UseIdx = 1
				self.Valid = 1 if pj.McuComm.Mcu.IsRcvHeading else 0
			elif gyro_type == 1 :
				self.Heading = pj.GyroComm.Nmea.Heading
				self.UseIdx = 2
				self.Valid = 1 if pj.GyroComm.SubExtGyro.IsConnect() else 0
			elif gyro_type == 2:
				self.Heading = pj.GyroComm.Nmea.Heading
				self.UseIdx = 3
				self.Valid = 2
			elif gyro_type == 3:
				self.UseIdx = 4
				self.Valid = self.ExtValid
				self.Heading = self.ExtHeading
			elif gyro_type == 4:
				self.UseIdx = 5
				self.Valid = self.UserValid
				self.Heading = pj.Sys.GetGyroUserInput()
			else :  
				if pj.McuComm.Mcu.IsRcvHeading : 
					self.Heading = pj.McuComm.Mcu.Heading
					self.UseIdx = 1
					self.Valid = 1
				elif pj.GyroComm.SubExtGyro.IsConnect() :
					self.Heading = pj.GyroComm.Nmea.Heading
					self.UseIdx = 2
					self.Valid = 1
				else :
					self.UseIdx = 0
					self.Valid = 0
					self.Heading = 0
              
			if pj.NmeaComm.Nmea.IsValidHdt() or pj.NmeaComm.Nmea.IsValidHtg() or pj.NmeaComm.Nmea.IsValidHtm() : 
				self.ExtIdx = 1
				self.ExtHeading = pj.NmeaComm.Nmea.Heading
				self.ExtValid = 1
			elif pj.ConComm.Nmea.IsValidHdt() or pj.ConComm.Nmea.IsValidHtg() or pj.ConComm.Nmea.IsValidHtm() : 
				self.ExtIdx = 2
				self.ExtHeading = pj.ConComm.Nmea.Heading
				self.ExtValid = 1
			else : 
				self.ExtIdx = 0
				self.ExtValid = 0
    def GetArray(self):
        from Project import pj 
        dat = { 
            'Source': self.UseIdx,
            'Valid': self.Valid,
            'UseIdx': self.UseIdx,
            'Heading': self.Heading,
            'Type': self.Type,
            'GyroSwitch':pj.GyroSwitch,
            'Nmea2000':{
                'Valid': pj.McuComm.Mcu.IsRcvHeading,
                'Heading': pj.McuComm.Mcu.Heading,
            },
            'User':{
                'Valid': self.UserValid,
                'Heading': pj.Sys.GetGyroUserInput(),
            },
            'Extenal':{
                'Source': self.ExtIdx,
                'Valid': self.ExtValid,
                'Heading': self.ExtHeading,
            },
            'Manual':{
                'Valid': pj.GyroComm.SubExtGyro.IsConnect(),
                'Heading': pj.GyroComm.Nmea.Heading,
            }
        }
        return dat
