#*-* coding: utf-8 *-*
from Module import *
from Util import *
import json


class Log(Module):
    def __init__(self,name):
        Module.__init__(self,name)
        self.LogArr = []
        self.Path = "/home/pi/proj/vcs/logs.json"
        # p = Thread(target=self.Worker)
        # p.start()
    def Save(self): 
        with open(self.Path, "w") as json_file:
            json.dump(self.LogArr, json_file, indent=4)
    def Load(self): 
        try:
            with open(self.Path, "r") as json_file:
                self.LogArr = json.load(json_file)
        except: print "Log, Load error." 
    def PushBootEvent(self):  self.Push({'dt':Util.Systime(),'name':'system','desc':'Booted system', 'data':"", 'type':0})
    def PushWebEvent(self,desc):  self.Push({'dt':Util.Systime(),'name':'setting','desc':desc, 'data':"", 'type':0})
    def PushConnected(self,dat): self.Push({'dt':Util.Systime(),'name':'system','desc':'Connected', 'data':dat, 'type':1})
    def PushDisconnected(self,dat): self.Push({'dt':Util.Systime(),'name':'system','desc':'Disonnected', 'data':dat, 'type':2})
    def PushGpsValid(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'GPS is valid', 'data':"", 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'GPS is not valid', 'data':"", 'type':2})
    def PushGyroValid(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'Gyro is valid', 'data':"", 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'Gyro is not valid', 'data':"", 'type':2})
    def PushAntLink(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'Antenna is linked', 'data':"", 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'Antenna is unlinked', 'data':"", 'type':2})
    def PushAntLock(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'Antenna is locked', 'data':"", 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'Antenna is unlocked', 'data':"", 'type':2})
    def PushAntSwitching(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'LBand path changed to Antenna-A', 'data':'(Auto)', 'type':1})
        elif tmp == 2 : self.Push({'dt':Util.Systime(),'name':'system','desc':'LBand path changed to antenna-B', 'data':'(Auto)', 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'LBand path is muted', 'data':'(Auto)', 'type':2})
    def PushRefDec(self,tmp): 
        if tmp == 1 : self.Push({'dt':Util.Systime(),'name':'system','desc':'Ref-Freq is detected', 'data':'', 'type':1})
        else : self.Push({'dt':Util.Systime(),'name':'system','desc':'Ref-Freq is not detected', 'data':'', 'type':2})
    def Push(self,event): 
        self.LogArr.append(event)
        if len(self.LogArr) > 100 : dat = self.LogArr.pop(0)
        self.Save()
    def PushEx(self,name,desc,dat,typ): 
        self.LogArr.append({'dt':Util.Systime(),'name':name,'desc':desc, 'data':dat, 'type':typ})
        if len(self.LogArr) > 100 : dat = self.LogArr.pop(0)
    def Pop(self): 
        dat = ""
        if len(self.LogArr) > 0 : dat = self.LogArr.pop(0)
        return dat
    def Get(self): 
        # print self.LogArr
        # for x in self.LogArr :
            # print x
        # return ""
        return self.LogArr