#-*- coding:utf-8 -*-
import json
from Protocol import * 
from DataList import * 

class MCU(Protocol):
    def __init__(self, name):
        Protocol.__init__(self, name)
        self.SwLBandMute = 0
        self.SwLBandTx = 0
        self.SwLBandRx = 0
        self.SwRefFreqTx1 = 0
        self.SwRefFreqTx2 = 0
        self.SwRefFreqRx = 0
        self.DecTxInt = 0
        self.DecTxExt = 0
        self.DecTxModem = 0
        self.DecTxRefFreq = 0
        self.DecTxEmcon = 0
        self.DecRx = 0
        self.AttnRx1 = 0.0
        self.AttnRx2 = 0.0
        self.AttnTx1 = 0.0
        self.AttnTx2 = 0.0
        self.IsRcvHeading = 0
        self.Heading = 0
        self.Temperature = 0.0
        self.ModemCn = 0
        # self.DecLBandCnt = 0
        self.DecClick = 0;
        self.DecDeepClick = 0;
        #New - SysReset 210429
        self.SysReset = 0;
    def BurstGpsProc(self,line):
        from Project import pj 
        Protocol.CheckRcv(self)
        lines = line.split(',')
        # print line
        # print lines[11]
        try :
            if len(lines) > 10 : 
                if int(lines[11]) > 80 and self.SysReset==0 :
                    self.SysReset = 1
 
                if pj.InitializeReady :
                    if self.DecClick != int(lines[12]) : 
						# pj.Vcs.AntSel = int(lines[2])
						# print line + "(*), {} {} ".format(lines[2], pj.Vcs.AntSel)
						self.DecClick = int(lines[12])
						pj.Vcs.AntSel = int(lines[2])
                    elif self.DecDeepClick != int(lines[13]) : 
						self.DecDeepClick = int(lines[13])
						pj.Vcs.RefFreqSel = int(lines[4])
						# print line + "(**), "+ lines[4]
                else : 
                    self.DecClick = int(lines[12])
                    self.DecDeepClick = int(lines[13]) 
				
					
				
				# Error		
                # if pj.Vcs.AntSel != int(lines[2]) : self.DecLBandCnt += 1 
                # if self.DecLBandCnt > 10 : 
                    # pj.Vcs.AntSel = int(lines[2])
                    # self.DecLBandCnt = 0
					
                self.SwLBandMute = 0 if lines[6][0:1] == '0' else 1
                self.SwLBandTx = 0 if lines[6][1:2] == '0' else 1
                self.SwLBandRx = 0 if lines[6][2:3] == '0' else 1
                self.SwRefFreqTx1 = 0 if lines[7][0:1] == '0' else 1
                self.SwRefFreqTx2 = 0 if lines[7][1:2] == '0' else 1
                self.SwRefFreqRx = 0 if lines[7][2:3] == '0' else 1
                self.DecTxEmcon = 0 if lines[8][0:1] == '0' else 1
                self.DecTxInt = 0 if lines[8][1:2] == '0' else 1
                self.DecTxExt = 0 if lines[8][2:3] == '0' else 1
                self.DecTxModem = 0 if lines[8][3:4] == '0' else 1
                self.DecTxRefFreq = 0 if lines[8][4:5] == '0' else 1
                self.DecRx = 0 if lines[8][5:6] == '0' else 1
                self.IsRcvHeading = int(lines[9])
                self.Heading = float(lines[10])
                adcs = lines[14].split('/')
                if len(adcs) > 6 : 
                    self.Temperature = ((((4096.0-float(adcs[2]))*215.0)/4095.0)-65.0)*(3.0/5.0)
                    self.ModemCn = 0 if float(adcs[3]) < 20 else float(adcs[3])
             
        except: print "MCU - BurstGpsProc Error"
		
        # if len(lines) > 10 :
            # if pj.Vcs.AntSel != int(lines[2]) : self.DecLBandCnt += 1 
            # if self.DecLBandCnt > 10 : 
                # pj.Vcs.AntSel = int(lines[2])
                # self.DecLBandCnt = 0
            # self.SwLBandMute = 0 if lines[6][0:1] == '0' else 1
            # self.SwLBandTx = 0 if lines[6][1:2] == '0' else 1
                
    def GetModemCn(self):
        return self.ModemCn;
    def GetTemperature(self):
        return self.Temperature;
    def GetArray(self):
        dat = { 
            'Switch':{
                'LBand':{
                    'Mute': self.SwLBandMute,
                    'Tx': self.SwLBandTx,
                    'Rx': self.SwLBandRx,
                },'RefFreq':{
                    'Mute': self.SwRefFreqTx1,
                    'Tx': self.SwRefFreqTx2,
                    'Rx': self.SwRefFreqRx,
                },
            },
            'Detector':{
                'TxInt': self.DecTxInt,
                'TxExt': self.DecTxExt,
                'TxModem': self.DecTxModem,
                'TxRefFreq': self.DecTxRefFreq,
                'TxEmcon': self.DecTxEmcon,
                'DecRx': self.DecRx,
            },
            'Attn':{
                'Rx1': self.AttnRx1,
                'Rx2': self.AttnRx2,
                'Tx1': self.AttnTx1,
                'Tx2': self.AttnTx2,
            },
            'Nmea2000':{
                'Valid': self.IsRcvHeading,
                'Heading': self.Heading,
            },
            'Adc':{
                'Temperature': self.Temperature,
                'ModemCn': self.ModemCn,
            }
        }
        return dat