#-*- coding:utf-8 -*-
import serial
import time
from NMEA import *
from Communicator import *
from threading import Thread

class NmeaCommunicator(Communicator): 
    def __init__(self,name):
        Communicator.__init__(self,name)
        self.TxArr = []
        self.Nmea = NmeaFormatter()
        self.DevName = ''
        Communicator.ResetFlag(self)
        self.SubExtNmea = Communicator("SubExtNmea")
        self.SubExtNmea.ResetFlag()
        p = Thread(target=self.TxWorker)
        p.start()
    def Open(self,name,baudrate):
        self.out("Opend %s-%s"%(name,baudrate))
        self.DevName = name
        self.Comm = serial.Serial(name, baudrate)
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.Comm.close()
    def Start(self):
        line = ""
        while True: 
            ch  = self.Comm.read(1)
            line += ch          
            if ch == '\n':
				self.DatProc(line)
				line = ""	
    def DatProc(self,line):
        self.out(line)
        if len(line) < 5 : return 
        elif line[0:2] == '$G' or line[0:2] == '$H' : 
            self.out(line)
            self.SubExtNmea.SetFlag()
            self.Nmea.DatProc(line)
    def Send(self,dat):
        tmp = str(dat)
        tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def TxWorker(self):
        time.sleep(5)
        while True:
            time.sleep(0.1)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                self.Comm.write(dat.encode())
                # print dat
            # time.sleep(1)
            # dat = "$GPRMC,092750.000,A,5321.6802,N,00630.3372,W,0.02,31.66,280511,,,A*43\r\n"
            # if len(self.TxArr) > 0 : 
                # dat = self.TxArr.pop(0)
                # self.Comm.write(dat.encode())