#-*- coding:utf-8 -*-
import time
import json
from Module import *
from threading import Thread
import netifaces

file_path = "/home/pi/proj/vcs/conf.json"

class System(Module):
    def __init__(self,name):
        Module.__init__(self,name)
        self.GpsManipulationUse = 0
        self.GpsManipulationLat = 0.0
        self.GpsManipulationLon = 0.0
        self.Dat = self.DefaultConf()
        p = Thread(target=self.Worker)
        p.start()
    # Networks
    def GetAntAIP(self): return self.Dat['Interface']['AntA']['IP']
    def GetAntAPort(self): return self.Dat['Interface']['AntA']['Port']
    def GetAntBIP(self): return self.Dat['Interface']['AntB']['IP']
    def GetAntBPort(self): return self.Dat['Interface']['AntB']['Port']
    def GetWebIP(self): return self.Dat['Interface']['Web']['IP']
    def GetWebPort(self): return self.Dat['Interface']['Web']['Port']
    def GetAbsPort(self): return int(self.Dat['Interface']['Ports']['Abs'])
    # Serials
    def GetMcuName(self): return self.Dat['Interface']['Mcu']['Name']
    def GetMcuBaudrate(self): return self.Dat['Interface']['Mcu']['Baudrate']
    def GetAntSubName(self): return self.Dat['Interface']['AntSub']['Name']
    def GetAntSubBaudrate(self): return self.Dat['Interface']['AntSub']['Baudrate']
    def GetNmeaName(self): return self.Dat['Interface']['Nmea']['Name']
    def GetNmeaBaudrate(self): return self.Dat['Interface']['Nmea']['Baudrate']
    def GetNmeaFormat(self): return int(self.Dat['Interface']['Nmea']['Format'])
    def GetConsoleName(self): return self.Dat['Interface']['Console']['Name']
    def GetConsoleBaudrate(self): return self.Dat['Interface']['Console']['Baudrate']
    def GetConsoleFormat(self): return int(self.Dat['Interface']['Console']['Format'])
    def GetGyroName(self): return self.Dat['Interface']['Gyro']['Name']
    def GetGyroBaudrate(self): return self.Dat['Interface']['Gyro']['Baudrate']
    def GetGyroType(self): return int(self.Dat['Gyro']['Type'])
    # Serials with output format
    def GetGyroManualType(self): return self.Dat['Gyro']['ManualType']
    def GetGyroAutoSel(self): return self.Dat['Gyro']['AutoSel']
    def GetGyroUserInput(self): return self.Dat['Gyro']['UserInput']
    def GetGyroNmea0183Baudrate(self): return self.Dat['Gyro']['Baudrate']
    def GetGyroManualConverter(self): return self.Dat['Gyro']['Converter']
    def GetGyroManualSyncFreq(self): return self.Dat['Gyro']['SyncFreq']
    def GetGyroManualDirection(self): return self.Dat['Gyro']['Direction']  
    # ABS
    def GetAbsClass(self): return int(self.Dat['Absp']['ClassType'])  
    def GetAbsRfterm(self): return int(self.Dat['Absp']['RfTermType'])  
    def GetAbsIsUsing(self): return int(self.Dat['Absp']['IsUsing'])  
    def GetAbsExtLockSrcType(self): return int(self.Dat['Absp']['ExtLockSrcType'])  
    def GetAbsConsolOutputType(self): return int(self.Dat['Absp']['ConsolOutputType'])  
    # VCS
    def GetSyncMode(self): return int(self.Dat['Vcs']['Option']['Sync'])  
    # Set functions
    def SetInterface(self,obj): # Not work
		dat = {
			'AntA':{'IP':obj['AntA']['IP'], 'Port':obj['AntA']['Port'] },
			'AntB':{'IP':obj['AntB']['IP'], 'Port':obj['AntB']['Port'] },
			'Web':{'IP':'127.0.0.1', 'Port':obj['Web']['Port'] },
			'Mcu':{'Name':'/dev/ttyUSB6', 'Baudrate':1152000},
			'Nmea':{'Name':'/dev/ttyUSB3', 'Baudrate':obj['Nmea']['Baudrate'], 'Format':obj['Nmea']['Format']},
			'Console':{'Name':'/dev/ttyUSB2', 'Baudrate':obj['Console']['Baudrate'], 'Format':obj['Console']['Format'],},
			'Gyro':{'Name':'/dev/ttyUSB4', 'Baudrate':obj['Gyro']['Baudrate']},
			'AntSub':{'Name':'/dev/ttyUSB1', 'Baudrate':57600 },
			'Ports':{
				'Abs':obj['Ports']['Abs'],
				'Mnc':obj['Ports']['Mnc']
			},
        }
		self.Dat['Interface'] = dat
    def SetGyro(self,obj): 
        from Project import pj 
        if int(obj['Type']) == 1:
            pj.GyroComm.SetBaudrate(self.Dat['Interface']['Gyro']['Name'],obj['BaudrateNmea0183'])
            # print self.Dat['Interface']['Gyro']['Name'] 
            # print obj['BaudrateNmea0183']
        elif int(obj['Type']) == 2:
            pj.GyroComm.SetBaudrate(self.Dat['Interface']['Gyro']['Name'],obj['BaudrateSyncStep'])
            pj.GyroComm.SendForCustom(int(obj['Direction']),int(obj['SyncFreq']),int(obj['ManualType']),float(obj['Converter']))   
        elif int(obj['Type']) == 4:
            pj.GyroMgr.UserValid = 1
        dat = {
            'Type':obj['Type'],
            'ManualType':obj['ManualType'],
            'Direction':obj['Direction'],
            'SyncFreq':obj['SyncFreq'],
            'Converter':obj['Converter'],
            'BaudrateNmea0183':obj['BaudrateNmea0183'],
            'BaudrateSyncStep':obj['BaudrateSyncStep'],
            'UserInput':obj['UserInput'],
        }
        self.Dat['Gyro'] = dat
        self.Save()
        pj.GyroSyncStepStartupFlag = False;
    def SetGyroConverter(self,val): 
        from Project import pj 
        self.Dat['Gyro']['Converter'] = val
        self.Save()
        pj.GyroSyncStepStartupFlag = False;
        pj.GyroComm.SendForCustom(int(self.Dat['Gyro']['Direction'])
                                ,int(self.Dat['Gyro']['SyncFreq'])
                                ,int(self.Dat['Gyro']['ManualType'])
                                ,float(self.Dat['Gyro']['Converter']))
    def SetGps(self,obj): 
        from Project import pj 
        if self.Dat['Interface']['Nmea']['Baudrate'] != obj['Nmea']['Baudrate'] :
            pj.NmeaComm.SetBaudrate(self.Dat['Interface']['Nmea']['Name'],obj['Nmea']['Baudrate'])
        if self.Dat['Interface']['Console']['Baudrate'] != obj['Console']['Baudrate'] :
            pj.ConComm.SetBaudrate(self.Dat['Interface']['Console']['Name'],obj['Console']['Baudrate'])
        self.Dat['Interface']['Nmea']['Baudrate'] = obj['Nmea']['Baudrate']
        self.Dat['Interface']['Nmea']['Format'] = obj['Nmea']['Format']
        self.Dat['Interface']['Console']['Baudrate'] = obj['Console']['Baudrate']
        self.Dat['Interface']['Console']['Format'] = obj['Console']['Format']
        self.Save()
    def SetAbsp(self,obj):
		dat = {
			'IsUsing':obj['IsUsing'],
			'InterfaceType':obj['InterfaceType'],
			'ClassType':obj['ClassType'],
			'ExtLockSrcType':obj['ExtLockSrcType'],
			'LnbBand1Lo':obj['LnbBand1Lo'],
			'LnbBand2Lo':obj['LnbBand2Lo'],
			'LnbBand3Lo':obj['LnbBand3Lo'],
			'LnbBand4Lo':obj['LnbBand4Lo'],
			'RollOff':obj['RollOff'],
			'RfTermType':obj['RfTermType'],
			'ConsolOutputType':obj['ConsolOutputType'],	 
		}
		self.Dat['Absp'] = dat
		self.Save()
    def SetAntIf(self,obj):  
		self.Dat['Interface']['AntA'] = obj['AntA'] 
		self.Dat['Interface']['AntB'] = obj['AntB']
		self.Save()
    def SetNetwork(self,obj): 
		self.Dat['Interface']['Ports'] = obj['Ports']
		self.Save()
    def UpdateVcs(self): 
		from Project import pj 
		dat = {
            'Default':{
				'AntSel':pj.Vcs.AntSel, 
				'RefFreq':pj.Vcs.RefFreqSel,  
				'AttnRx1':pj.McuComm.Mcu.AttnRx1, 
				'AttnRx2':pj.McuComm.Mcu.AttnRx2, 
				'AttnTx1':pj.McuComm.Mcu.AttnTx1, 
				'AttnTx2':pj.McuComm.Mcu.AttnTx2, 
			},
            'Option':{
				'Sync':pj.Vcs.SyncMode, 
			},
        }
		self.Dat['Vcs'] = dat
		self.Save()
    def Save(self): 
        with open(file_path, "w") as json_file:
            json.dump(self.Dat, json_file, indent=4)
    def Load(self): 
        try:
            with open(file_path, "r") as json_file:
                self.Dat = json.load(json_file)
                # print self.Dat
        except:
            print "Creat New Configuration file"
            self.Dat = self.DefaultConf()
            self.Save()
    def Worker(self):
		while True:
			time.sleep(1)
    def GetArray(self,token):
		from Project import pj 
		dat = { 
			'Id':token,
			'System':{}, 
			'Network':{
				'Addr': netifaces.ifaddresses('eth1')[netifaces.AF_INET][0]['addr'],
				'Netmask': netifaces.ifaddresses('eth1')[netifaces.AF_INET][0]['netmask'],
				'Gateway': netifaces.gateways()['default'][2][0],
				'Mac': netifaces.ifaddresses('eth1')[17][0]['addr'],
			},
			'GpsManipulation':{
				'IsUsing':self.GpsManipulationUse,
				'Latitude':self.GpsManipulationLat,
				'Longitude':self.GpsManipulationLon
			},
		}
		dat['System'] = self.Dat
		return dat
    def GetJson(self,token):
        return json.dumps(self.GetArray(token))
    def Print(self):
		print(json.dumps(self.Dat, indent=4, sort_keys=True))
    def DefaultConf(self):
        return { 
            'Vcs':{
                'Default':{
                    'AntSel':3, 
                    'RefFreq':1,  
                    'AttnRx1':0, 
                    'AttnRx2':0, 
                    'AttnTx1':0, 
                    'AttnTx2':0, 
                },
                'Option':{
                    'Sync':0, 
                },
            },
            'Interface':{
                'AntA':{'IP':'192.168.1.3', 'Port':2500 },
                'AntB':{'IP':'192.168.1.220', 'Port':2500 },
                'Web':{'IP':'127.0.0.1', 'Port':52000 },
                'Mcu':{'Name':'/dev/ttyUSB6', 'Baudrate':1152000 },
                'Nmea':{'Name':'/dev/ttyUSB3', 'Baudrate':4800 , 'Format':0},
                'Console':{'Name':'/dev/ttyUSB2', 'Baudrate':4800 , 'Format':0},
                'Gyro':{'Name':'/dev/ttyUSB4', 'Baudrate':4800 },
                'AntSub':{'Name':'/dev/ttyUSB1', 'Baudrate':57600 },
                'Ports':{'Abs':5001, 'Mnc':5002 },
            },
            'Absp':{
                'IsUsing':1,
                'InterfaceType':1,
                'ClassType':0,
                'ExtLockSrcType':0,
                'LnbBand1Lo':10000,
                'LnbBand2Lo':10750,
                'LnbBand3Lo':11300,
                'LnbBand4Lo':9750,
                'RollOff':0.20,
                'RfTermType':0,
                'ConsolOutputType':0,
            },
            'OutputFormat':{
                'Nmea':{
                    'Console':0,
                    'Nmea':0,
                }
            },
            'Gyro':{
                'Type':0,
                'BaudrateSyncStep':0,
                'BaudrateNmea0183':0,
                'ManualType':0,
                'Direction':0,
                'SyncFreq':0,
                'Converter':0,
                'UserInput':0,
            }
        } 
            
