#*-* coding: utf-8 *-*
import json
from socket import *
from Communicator import *


class WebCommunicator(Communicator):
    def __init__(self,name):
        Communicator.__init__(self,name)
    def Init(self,ip,port):
        self.IP = str(ip)
        self.Port = int(port)
        Communicator.ResetFlag(self)
    def JsonDatProc(self,dat): 
        from Project import pj 
        req = json.loads(dat)
        # print dat
        # try: 
        # print req['Id']
        # Antennas Information
        if req['Id'] == "get-anta-info" :
            tmp = dat
            if pj.AntA != None : tmp = pj.AntA.GetJson("resp-anta-info")
            self.c.sendall(tmp)
        elif req['Id'] == "get-antb-info" :
            tmp = dat
            if pj.AntB != None : tmp = pj.AntB.GetJson("resp-antb-info")
            self.c.sendall(tmp)
        # Antennas Information
        elif req['Id'] == "get-vcs-info" :
            tmp = pj.GetJson("resp-vcs-info")
            self.c.sendall(tmp)
        # Configureation
        elif req['Id'] == "get-conf" :
            tmp = pj.Sys.GetJson("resp-conf")
            self.c.sendall(tmp)
        elif req['Id'] == "save-conf" :  
            tmp = pj.Sys.Save()
            self.c.sendall(dat) 
        elif req['Id'] == "reload-conf" :
            tmp = pj.Sys.Load()
            tmp = pj.Sys.GetJson("reload-conf")
            self.c.sendall(tmp) 
        elif req['Id'] == "edit-conf" :
            if req['Group'] == "Absp" : pj.Sys.SetAbsp(req['Data'])
            elif req['Group'] == "Gyro" : pj.Sys.SetGyro(req['Data']) 
            elif req['Group'] == "Gps" : pj.Sys.SetGps(req['Data'])
            elif req['Group'] == "Antif" : 
                pj.Sys.SetAntIf(req['Data'])
                pj.Reboot()
                pj.Log.PushWebEvent('Rebooted')
            elif req['Group'] == "Network" : 
                pj.Sys.SetNetwork(req['Data']) 
                Util.UpdateNetwork(req['Data']) 
                pj.Reboot()
                pj.Log.PushWebEvent('Rebooted')
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("edit-conf")
            self.c.sendall(tmp)
            # print req['msg'] 
        elif req['Id'] == "set-gyro-ssf" :	
            # print req
            val = float(req['value'])
            pj.Sys.SetGyroConverter(val)
        elif req['Id'] == "set-fake" :
            pj.Sys.GpsManipulationUse = int(req['Data']['Use'])
            pj.Sys.GpsManipulationLat = float(req['Data']['Lat'])
            pj.Sys.GpsManipulationLon = float(req['Data']['Lon'])
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-fake")
            self.c.sendall(tmp)
        elif req['Id'] == "set-mcu-sync" :
            pj.Vcs.SyncMode = int(req['value'])
            pj.Sys.UpdateVcs()
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-mcu")
            self.c.sendall(tmp)
        elif req['Id'] == "set-mcu-ant" :
            pj.Vcs.AntSel = int(req['value'])
            # Reflect the last antenna seletion. 
            pj.AntAutoSel = pj.Vcs.AntSel if pj.Vcs.AntSel == 1 or pj.Vcs.AntSel == 2 else pj.AntAutoSel
            # print pj.AntAutoSel
            # print req['value']
            pj.McuComm.SendAntSelect(req['value'])
            pj.Sys.UpdateVcs()
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-mcu")
            self.c.sendall(tmp)
        elif req['Id'] == "set-mcu-freq" :
            pj.Vcs.RefFreqSel = int(req['value'])
            pj.McuComm.SendRefFreqSelect(req['value'])
            pj.Sys.UpdateVcs()
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-mcu")
            self.c.sendall(tmp)
        elif req['Id'] == "set-mcu-freqmnl" :
            dat0 = int(req['value0'])
            dat1 = int(req['value1'])
            dat2 = int(req['value2'])
            pj.McuComm.SendRefFreqManual(dat0,dat1,dat2)  
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-mcu")
            self.c.sendall(tmp)
        elif req['Id'] == "set-mcu-attn" :
            if req['target'] == 0 : 
                pj.McuComm.Mcu.AttnRx1 = req['value']
            elif req['target'] == 1 : 
                pj.McuComm.Mcu.AttnRx2 = req['value']
            elif req['target'] == 2 : 
                pj.McuComm.Mcu.AttnTx1 = req['value']
            elif req['target'] == 3 : 
                pj.McuComm.Mcu.AttnTx2 = req['value']
            pj.McuComm.SendAttn(req['target'],req['value'])
            pj.Sys.UpdateVcs()
            
            pj.Log.PushWebEvent(req['msg'])
            tmp = pj.Sys.GetJson("resp-mcu")
            # print tmp
            self.c.sendall(tmp)
        # except: self.out('Object is error.')
        # if req['Id'] == "set-mcu-attn" :
            # self.McuComm.Mcu.AttnRx1 = req['value']
        
        # if req['Id'] == "get-conf" :
            # # tmp = pj.McuComm.Mcu.GetJson("resp-mcu-info")
            # tmp = pj.Sys.GetJson("resp-conf")
            # self.c.sendall(tmp)
    def Start(self):
        s = socket(AF_INET, SOCK_STREAM)
        s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        s.bind((self.IP, self.Port))
        s.listen(5)
        self.out('Start Listen')
        while 1:
            try: 
                (c, addr) = s.accept() 
                self.c = c
                line = c.recv(1024)
                # self.Proc(line.decode())
                # print('Received from', addr, line.decode())
            except: self.out('Receive Error') 
            self.JsonDatProc(line)
            c.close()
            self.SetFlag()
        s.close()
        self.out('Socket Closed(*)')
        

