import serial
import time
import datetime
import json
import sqlite3


class Commnunicator():
    def __init__(self):
        
        sqlconn = sqlite3.connect("/home/pi/proj/acu/dev/dump/acu.db")
        
        # print "DROP TABLE burst."
        # sqlconn.execute("DROP TABLE burst")
        # tmp = 'CREATE TABLE burst(id INTEGER PRIMARY KEY AUTOINCREMENT, ' \
        tmp = 'CREATE TABLE IF NOT EXISTS burst(id INTEGER PRIMARY KEY AUTOINCREMENT, ' \
                                    'datetime TEXT, ' \
                                    'driving INTEGER, ' \
                                    'static_on INTEGER, ' \
                                    'nim_lock INTEGER, ' \
                                    'sch_on INTEGER, ' \
                                    'trk_on INTEGER, ' \
                                    'con_on INTEGER, ' \
                                    'sch_type INTEGER, ' \
                                    'trk_type INTEGER, ' \
                                    'ant_mode INTEGER, ' \
                                    'ant_step INTEGER, ' \
                                    'skew_mode INTEGER, ' \
                                    'txband INTEGER, ' \
                                    'rxband INTEGER, ' \
                                    'rxpol INTEGER, ' \
                                    'txpol INTEGER, ' \
                                    'trxpol INTEGER, ' \
                                    'jogmod INTEGER, ' \
                                    'tx_on INTEGER, ' \
                                    'gyromode INTEGER, ' \
                                    'asipass_on INTEGER, ' \
                                    'sat_id INTEGER, ' \
                                    'sat_lon REAL, ' \
                                    'dvb_agc INTEGER, ' \
                                    'dvb_cn INTEGER, ' \
                                    'rssd INTEGER, ' \
                                    'rssd_cn INTEGER, ' \
                                    'gps_valid INTEGER, ' \
                                    'gps_lat REAL, ' \
                                    'gps_lon REAL, ' \
                                    'gps_speed REAL, ' \
                                    'gps_trkang REAL, ' \
                                    'sat_name TEXT, ' \
                                    'nid INTEGER, ' \
                                    'orbital REAL, ' \
                                    'ele REAL, ' \
                                    'azi REAL, ' \
                                    'skew REAL, ' \
                                    'rel REAL, ' \
                                    'heding REAL, ' \
                                    'refbank REAL, ' \
                                    'ahrs_roll REAL, ' \
                                    'ahrs_pitch REAL, ' \
                                    'ahrs_yaw REAL, ' \
                                    'tilt REAL, ' \
                                    'level REAL, ' \
                                    'modem_lock INTEGER, ' \
                                    'extsch_type INTEGER, ' \
                                    'extsch_thd INTEGER, ' \
                                    'exttrk_type INTEGER, ' \
                                    'fc INTEGER, ' \
                                    'ec INTEGER, ' \
                                    'pt_err REAL, ' \
                                    'tmp REAL ' \
                                    ' )'
        sqlconn.execute(tmp)
        print "CREATE TABLE burst."
        
        sqlconn.commit() 
        sqlconn.close()

    def Open(self,name,baudrate):
        self.DevName = name
        self.Comm = serial.Serial(name, baudrate)
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.Comm.close()
    def Systime(self): 
        dt = str(datetime.datetime.now())
        return dt[0:23]
    def Sysdate(self): 
        dt = str(datetime.datetime.now())
        return dt[0:10]
    def Start(self):
        line = ""
        burst = {'date':"",'list':[]}
        hour = -1;
        
        driving = 0
        static_on = 0
        nim_lock = 0
        sch_on = 0
        trk_on = 0
        con_on = 0
        sch_type = 0
        sch_thd = 0
        trk_type = 0
        ant_mode = 0
        ant_step = 0
        skew_mode = 0
        txband = 0
        rxband = 0
        rxpol = 0 
        txpol = 0 
        trxpol = 0
        jogmod = 0
        tx_on = 0 
        gyromode = 0 
        asipass_on = 0 
        sat_id = 0 
        sat_lon = 0.0  
        dvb_agc = 0 
        dvb_cn = 0 
        rssd = 0
        rssd_cn = 0 
        gps_valid = 0 
        gps_lat = 0.0  
        gps_lon = 0.0  
        gps_speed = 0.0 
        gps_trkang = 0.0 
        sat_name = "" 
        nid = 0
        orbital = 0.0  
        ele = 0.0  
        azi = 0.0  
        skew = 0.0 
        rel = 0.0  
        heding = 0.0  
        refbank = 0.0  
        ahrs_roll = 0.0  
        ahrs_pitch = 0.0 
        ahrs_yaw = 0.0  
        tilt = 0.0  
        level = 0.0 
        modem_lock = 0 
        extsch_type = 0 
        extsch_thd = 0 
        exttrk_type = 0 
        fc = 0 
        ec = 0 
        pt_err = 0.0 
        tmp = 0.0  
        
        err_read = 0
        err_format = 0
        db_insert = 0
        while True: 
            try :
                ch  = self.Comm.read(1)
            except: 
                print('* Read Error ')
                continue
                
            line += ch    
            if ch == '\n':
                # self.DatProc(line)
                if line[0:13] == '$KB,DAT_S,STS' :
                    dat = line.split(',')
                    
                    for idx, val in enumerate(dat):
                        """ Check to vaild the burst message """
                        if idx < 3 or idx > len(dat) - 2 : continue
                        if val[0:2] == "Aa" : burst['list'] = []
                        burst['list'].append(val)
                        """ Check to vaild the burst message """
                        
                        try :
                        
                            if val[0:2] == "Aa" : driving = int(val[2:len(val)])
                            elif val[0:2] == "Ab" : static_on = int(val[2:len(val)])
                            elif val[0:2] == "Ac" : nim_lock = int(val[2:len(val)])
                            elif val[0:2] == "An" : sch_on = int(val[2:len(val)])
                            elif val[0:2] == "Ad" : trk_on = int(val[2:len(val)])
                            elif val[0:2] == "Ao" : con_on = int(val[2:len(val)])
                            elif val[0:2] == "Ae" : sch_type = int(val[2:len(val)])
                            elif val[0:2] == "Af" : trk_type = int(val[2:len(val)])
                            elif val[0:2] == "Ah" : ant_mode = int(val[2:len(val)])
                            elif val[0:2] == "Ai" : ant_step = int(val[2:len(val)])
                            elif val[0:2] == "Aj" : skew_mode = int(val[2:len(val)])
                            elif val[0:2] == "Au" : txband = int(val[2:len(val)])
                            elif val[0:2] == "Ak" : rxband = int(val[2:len(val)])
                            elif val[0:2] == "Av" : txpol = int(val[2:len(val)]) 
                            elif val[0:2] == "Al" : rxpol = int(val[2:len(val)]) 
                            elif val[0:2] == "Am" : trxpol = int(val[2:len(val)])
                            elif val[0:2] == "Aq" : jogmod = int(val[2:len(val)])
                            elif val[0:2] == "As" : tx_on = int(val[2:len(val)]) 
                            elif val[0:2] == "Ar" : gyromode = int(val[2:len(val)]) 
                            elif val[0:2] == "At" : asipass_on = int(val[2:len(val)]) 
                            elif val[0:2] == "Ba" : sat_id = int(val[2:len(val)]) 
                            elif val[0:2] == "Bb" : sat_lon = float(val[2:len(val)]) 
                            elif val[0:2] == "Bc" : dvb_agc = int(val[2:len(val)]) 
                            elif val[0:2] == "Bd" : dvb_cn = int(val[2:len(val)]) 
                            elif val[0:2] == "Be" : rssd = int(val[2:len(val)])
                            elif val[0:2] == "Bf" : rssd_cn = int(val[2:len(val)]) 
                            elif val[0:2] == "Ag" : gps_valid = int(val[2:len(val)]) 
                            elif val[0:2] == "Bg" : gps_lat = float(val[2:len(val)]) 
                            elif val[0:2] == "Bh" : gps_lon = float(val[2:len(val)]) 
                            elif val[0:2] == "Bj" : gps_speed = float(val[2:len(val)])
                            elif val[0:2] == "Bk" : gps_trkang = float(val[2:len(val)])
                            elif val[0:2] == "Bl" : sat_name = str(val[2:len(val)])
                            elif val[0:2] == "Bm" : nid = int(float(val[2:len(val)]))
                            elif val[0:2] == "Bn" : orbital = float(val[2:len(val)]) 
                            elif val[0:2] == "Cb" : ele = float(val[2:len(val)]) 
                            elif val[0:2] == "Cc" : azi = float(val[2:len(val)]) 
                            elif val[0:2] == "Ea" : skew = float(val[2:len(val)])
                            elif val[0:2] == "Ed" : rel = float(val[2:len(val)]) 
                            elif val[0:2] == "Xc" : heding = float(val[2:len(val)]) 
                            elif val[0:2] == "Ca" : refbank = float(val[2:len(val)]) 
                            elif val[0:2] == "Da" : ahrs_roll = float(val[2:len(val)]) 
                            elif val[0:2] == "Db" : ahrs_pitch = float(val[2:len(val)])
                            elif val[0:2] == "Dc" : ahrs_yaw = float(val[2:len(val)]) 
                            elif val[0:2] == "Eb" : tilt = float(val[2:len(val)]) 
                            elif val[0:2] == "Ec" : level = float(val[2:len(val)])
                            elif val[0:2] == "Xd" : modem_lock = int(float(val[2:len(val)]))
                            elif val[0:2] == "Xh" : extsch_type = int(val[2:len(val)]) 
                            elif val[0:2] == "Xi" : extsch_thd = int(val[2:len(val)]) 
                            elif val[0:2] == "Xj" : exttrk_type = int(val[2:len(val)]) 
                            elif val[0:2] == "Yb" : fc = int(val[2:len(val)], 16) 
                            elif val[0:2] == "Za" : ec = int(val[2:len(val)], 16) 
                            elif val[0:2] == "Xk" : pt_err = float(val[2:len(val)])
                            elif val[0:2] == "Xa" : tmp = float(val[2:len(val)]) 
                        except: 
                            print('* Burst Error ')
                            continue
                        
                        
                        
                         
                        print "{},"\
                        "{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, "\
                        "{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, "\
                        "{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, "\
                        "{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, "\
                        "{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, "\
                        "{}, {}, {} ".format(self.Systime(), 
                        driving, static_on, nim_lock, sch_on, trk_on, con_on, sch_type, trk_type, ant_mode, ant_step, 
                        skew_mode, txband, rxband, txpol, rxpol, trxpol, jogmod, tx_on, gyromode, asipass_on, 
                        sat_id, sat_lon, dvb_agc, dvb_cn, rssd, rssd_cn, gps_valid, gps_lat, gps_lon, gps_speed, 
                        gps_trkang, sat_name, nid, orbital, ele, azi, skew, rel, heding, refbank, 
                        ahrs_roll, ahrs_pitch, ahrs_yaw, tilt, level, modem_lock, extsch_type, extsch_thd, exttrk_type, fc, 
                        ec, pt_err, tmp
                        )
                        
                        
                        
                        """ Post processing """
                        if val[0:2] == "Za" : 
                            # print("----------------------------------------")
                            if burst['list'][0][0:2] != "Aa" : continue
                            burst['date'] = self.Systime()
                            
                            
                            try :
                                sqlconn = sqlite3.connect("/home/pi/proj/acu/dev/dump/acu.db")
                                cur = sqlconn.cursor()                         
                                sql = "insert into burst(datetime,"\
                                "driving, static_on, nim_lock, sch_on, trk_on, con_on, sch_type, trk_type, ant_mode, ant_step, "\
                                "skew_mode, txband, rxband, txpol, rxpol, trxpol, jogmod, tx_on, gyromode, asipass_on, "\
                                "sat_id, sat_lon, dvb_agc, dvb_cn, rssd, rssd_cn, gps_valid, gps_lat, gps_lon, gps_speed, "\
                                "gps_trkang, sat_name, nid, orbital, ele, azi, skew, rel, heding, refbank, "\
                                "ahrs_roll, ahrs_pitch, ahrs_yaw, tilt, level, modem_lock, extsch_type, extsch_thd, exttrk_type, fc, "\
                                "ec, pt_err, tmp"\
                                ") values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
                                # print sql
                                cur.execute(sql, (self.Systime(), 
                                driving, static_on, nim_lock, sch_on, trk_on, con_on, sch_type, trk_type, ant_mode, ant_step, 
                                skew_mode, txband, rxband, txpol, rxpol, trxpol, jogmod, tx_on, gyromode, asipass_on, 
                                sat_id, sat_lon, dvb_agc, dvb_cn, rssd, rssd_cn, gps_valid, gps_lat, gps_lon, gps_speed, 
                                gps_trkang, sat_name, nid, orbital, ele, azi, skew, rel, heding, refbank, 
                                ahrs_roll, ahrs_pitch, ahrs_yaw, tilt, level, modem_lock, extsch_type, extsch_thd, exttrk_type, fc, 
                                ec, pt_err, tmp
                                ))
                                sqlconn.commit()
                                sqlconn.close()
                            except: 
                                print('* DB Error ')
                                continue
                line = ""	
    def Run(self):
        self.Open('/dev/ttyUSB5',57600)
        self.Start()
        
        

Comm1 = Commnunicator()
Comm1.Run()