"use strict";
/*
	hhwang
	20201206 Create
	KNS Inc.
*/

var kChart = {
	AntA: {NimAgc:[{data:[]}],NimQty:[{data:[]}],Rssd:[{data:[]}],RssdCn:[{data:[]}]}, 
	AntB: {NimAgc:[{data:[]}],NimQty:[{data:[]}],Rssd:[{data:[]}],RssdCn:[{data:[]}]},
	IsEmpty: function(ant){ ant.NimAgc[0].data.length > 5 ? false : true },
	InitData: function(dat){
		var tmp = this.AntA
		for(i=0;i<120;i++) {
			tmp.NimAgc[0].data.push({x:i, y:parseInt(dat.NimAgc.Value)});
			tmp.NimQty[0].data.push({x:i, y:parseInt(dat.NimQuality.Value)});
			tmp.Rssd[0].data.push({x:i, y:parseInt(dat.Rssd.Value)});
			tmp.RssdCn[0].data.push({x:i, y:parseInt(dat.RssdCn.Value)});
		}
		return tmp;
	},
	Option: function(title,avg,max,color){
		return {
			chart: {
				id: 'chart-strip', type: 'area', height: 150,
				toolbar: { show: false },
				animations:{ enabled:true, dynamicAnimation: { enabled: false, speed: 500 } }
			},
			series: [{data:[]}],
			colors: [color],
			xaxis: { axisBorder: { show: false }, axisTicks: { show: false }, labels: { show: false } ,},
			yaxis: { axisBorder: { show: false }, axisTicks: { show: false }, labels: { show: false } },
			stroke: { curve: 'smooth', width: 2.5, },
			dataLabels: { enabled: false, },
			fill: { type: 'gradient',  opacity: 1, 
				gradient: { type: "vertical", shadeIntensity: 0.55, gradientToColors: undefined, inverseColors: true, opacityFrom: 1,
						opacityTo: 0.1, stops: [5, 10, 100], colorStops: [] } },
			grid: { strokeDashArray: 4,  yaxis: { lines: { show: false }  },  },
			annotations: { 
				strokeDashArray: 4,
				opacity: 0.2,
				yaxis: [
					{ y:avg, borderColor: color, label: { borderColor: color+'40', style: { color: '#444', background: color+'40', }, text: 'AVG  '+avg.toString(),}},
					{ y:max, borderColor: color, label: { borderColor: color+'40', style: { color: '#444', background: color+'40', }, text: 'MAX  '+max.toString(),}},
				]},
			title: {
				text: title, align: 'center', margin: 10, offsetX: 0, offsetY: 0, floating: false,
				style: { fontSize:  '13px', fontWeight:  'light', color: color
				},
			}
		}
	},
	OptA: function(title,avg,max){ return this.Option(title,avg,max,'#1bc5bd')},
	OptB: function(title,avg,max){ return this.Option(title,avg,max,'#6993ff')}, 
	
}

var DrawStripChart = function(id,opt){
	var chart = new ApexCharts(document.querySelector("#"+id), opt);
	chart.render();
	return chart;
}


window.onload = function() {	

	ChartAntA = DrawStripChart('anta-chart', kChart.OptA('Antenna A',0,0));
	ChartAntB = DrawStripChart('antb-chart', kChart.OptB('Antenna A',0,0));
	
	setInterval(function() { GetStatus("get-anta-info")}, 500);
	setInterval(function() { GetStatus("get-antb-info")}, 500);
	setInterval(function() { GetStatus("get-vcs-info")}, 500);
	
	//Send event
	setInterval(function(){ if(commands.length>0) SendEvent(commands.shift());}, 30);
};

var ChartAntA = null
function SetAntInfo(type,dat,idx,cdata){
	// if(kChart.IsEmpty(cdata)) cdata = kChart.InitData(dat)
	
	var title = 'Antenna A, ';
	var sch = 0, trk = 0
	if(dat.SearchingType.Value !=5){ sch = dat.SearchingType.Value, trk = dat.TrackingType.Value }
	else{ sch = dat.ExternalSearchingType.Value, trk = dat.ExternalTrackingType.Value, title += '[EXT] ' }
	title += AntDef.DrivingStatus[dat.DrivingStatus.Value]+' - ';
	if(dat.DrivingStatus.Value!=3) title += AntDef.SchType[sch];
	else title += AntDef.TrkType[trk];
	
	cdata.NimAgc[0].data.push({x:idx, y:parseInt(dat.NimAgc.Value)});
	cdata.NimQty[0].data.push({x:idx, y:parseInt(dat.NimQuality.Value)});
	cdata.Rssd[0].data.push({x:idx, y:parseInt(dat.Rssd.Value)});
	cdata.RssdCn[0].data.push({x:idx, y:parseInt(dat.RssdCn.Value)});
	if(cdata.NimAgc[0].data.length > 120)cdata.NimAgc[0].data.shift(),cdata.NimQty[0].data.shift(),cdata.Rssd[0].data.shift(),cdata.RssdCn[0].data.shift();
	// console.log("sch:"+dat.SearchingType.Value+","+"trk:"+dat.TrackingType.Value+","+"esch:"+dat.SearchingType.Value+","+"etrk:"+dat.SearchingType.Value+",");
	var tmp = null;
	if(dat.DrivingStatus.Value!=3){
		if(sch==1) tmp = cdata.NimQty
		else if(sch==3) tmp = cdata.Rssd
		else if(sch==4) tmp = cdata.RssdCn	
		else tmp = cdata.NimAgc
	}else{
		if(trk==1) tmp = cdata.NimQty
		else if(trk==2) tmp = cdata.Rssd
		else if(trk==3) tmp = cdata.RssdCn
		else tmp = cdata.NimAgc
	}
	
	var avg = 0, max = 0;
	for(i=0;i<tmp[0].data.length;i++){ 
		avg += tmp[0].data[i].y
		if(max < tmp[0].data[i].y) max = tmp[0].data[i].y;
	}
	
	return { title:title, cdata: cdata, active:tmp, max:max, avg:parseInt(avg/tmp[0].data.length)}
}

function FillAntData(type,dat){	
	$('.'+type).find('.lock').html(AntDef.Lock[dat.NimLock.Value] +' / '+ AntDef.Lock[parseInt(dat.ModemLock.Value)])
	$('.'+type).find('.opstep').html(AntDef.DrivingStatus[dat.DrivingStatus.Value])
	$('.'+type).find('.opmode').html(AntDef.DrivingMode[dat.DrivingMode.Value])
	$('.'+type).find('.static').html(AntDef.OnOff[dat.Static.Value])
	$('.'+type).find('.axipass').html(AntDef.OnOff[dat.AsiPass.Value])
	$('.'+type).find('.gyromode').html(AntDef.GyroMode[dat.GyroMode.Value])
	$('.'+type).find('.skewmode').html(AntDef.SkewMode[dat.SkewMode.Value])
	var schidx = dat.ExternalSearchingType.Value;
	var tmp = AntDef.SchType[schidx] ;
	if(schidx==0||schidx==1||schidx==3||schidx==4)
		tmp += ' ('+dat.ExternalLockThreshold.Value+')'
	$('.'+type).find('.extschtype').html(tmp)
	// $('.antb').find('.extschthd').html(dat.DrivingStatus.Value)
	$('.'+type).find('.exttrktype').html(AntDef.TrkType[dat.ExternalTrackingType.Value])

	$('.'+type).find('.nimval').html(dat.NimAgc.Value +' / '+dat.NimQuality.Value)
	$('.'+type).find('.rssdval').html(dat.Rssd.Value +' / '+dat.RssdCn.Value)

	$('.'+type).find('.heading').html(dat.Heading.Value+'&deg')
	$('.'+type).find('.elevation').html(dat.Elevation.Value+'&deg')
	$('.'+type).find('.azimuth').html(dat.Azimuth.Value+'&deg')
	$('.'+type).find('.skew').html(dat.Skew.Value+'&deg')

	$('.'+type).find('.sat-id').html(dat.SatNum.Value)
	$('.'+type).find('.sat-name').html(dat.SatName.Value)
	$('.'+type).find('.sat-lon').html(dat.SatLon.Value+'&deg')
	$('.'+type).find('.band').html(AntDef.Band[dat.RxBand.Value])
	$('.'+type).find('.polarity').html(AntDef.Polarity[dat.RxPolarity.Value])
	$('.'+type).find('.schtype').html(AntDef.SchType[dat.SearchingType.Value])
	$('.'+type).find('.trktype').html(AntDef.TrkType[dat.TrackingType.Value])

	$('.'+type).find('.gps-status').html(AntDef.GpsStatus[dat.GpsStatus.Value])
	$('.'+type).find('.gps-lon').html(dat.Latitude.Value)
	$('.'+type).find('.gps-lat').html(dat.Longitude.Value)
	$('.'+type).find('.gps-info').html(dat.GpsSpeed.Value +'m&middot;s / '+dat.GpsTrackAngle.Value+'&deg')

	$('.'+type).find('.temprature').html(dat.Temperature.Value+'&deg')
	$('.'+type).find('.code').html(dat.FunctionCode.Value +' / '+dat.ErrorCode.Value)
}


var anta_rx_idx = 100, antb_rx_idx = 100;;
function SetAntInfoA(dat){
	var type = 'anta';
	var c = SetAntInfo(type,dat,anta_rx_idx++,kChart.AntA)
	kChart.AntA = c.cdata;	
	ChartAntA.updateOptions(kChart.OptA(c.title,c.avg, c.max))
	ChartAntA.updateSeries(c.active)
	FillAntData(type,dat)
}
function SetAntInfoB(dat){
	var type = 'antb';
	var c = SetAntInfo(type,dat,antb_rx_idx++,kChart.AntB)
	kChart.AntB = c.cdata;	
	ChartAntB.updateOptions(kChart.OptB(c.title,c.avg, c.max))
	ChartAntB.updateSeries(c.active)
	FillAntData(type,dat)
}
