"use strict";
/* 	
	[KNS Inc] hhwang, 20201206 
	0.001 Create
	0.010 Test ApecChart
	0.015 Applied chart 
	0.100 refactoring
*/ 

window.onload = function() {	
	//Addedn UI event
	// load.oprun();
	$('.mnc').find(".lband-mute").click(function(){ commands.push({Id:"set-mcu-ant",value:0,msg:'LBand path is muted'}); } );
	$('.mnc').find(".lband-a").click(function(){ commands.push({Id:"set-mcu-ant",value:1,msg:'LBand path changed to antenna-A'}); } );
	$('.mnc').find(".lband-b").click(function(){ commands.push({Id:"set-mcu-ant",value:2,msg:'LBand path changed to antenna-B'}); } );
	$('.mnc').find(".lband-auto").click(function(){ commands.push({Id:"set-mcu-ant",value:3,msg:'LBand path is set to auto-mode'}); } );
	$('.mnc').find(".ref-int").click(function(){ commands.push({Id:"set-mcu-freq",value:0,msg:'Ref-Signal path changed to internal'}); } );
	$('.mnc').find(".ref-ext").click(function(){ commands.push({Id:"set-mcu-freq",value:1,msg:'Ref-Signal path changed to external'}); } );
	$('.mnc').find(".ref-mod").click(function(){ commands.push({Id:"set-mcu-freq",value:2,msg:'Ref-Signal path changed to modem'}); } );
	$('.mnc').find(".sync-off").click(function(){ commands.push({Id:"set-mcu-sync",value:0,msg:'SyncMode is set to off'}); } );
	$('.mnc').find(".sync-on").click(function(){ commands.push({Id:"set-mcu-sync",value:1,msg:'SyncMode is set to on'}); } );
	$('.gyro-ssf').find(".apply").click(function(){ commands.push({Id:"set-gyro-ssf",value:($('.gyro-ssf').find(".converter").val()),msg:'Converter is seted'}); } );

	kChart.A = DrawStripChart('anta-chart', kChart.OptA('Antenna A',0,0));
	kChart.B = DrawStripChart('antb-chart', kChart.OptB('Antenna B',0,0));
	
	GetStatus("get-conf");
	setInterval(function() { GetStatus("get-anta-info")}, 500);
	setInterval(function() { GetStatus("get-antb-info")}, 500);
	setInterval(function() { GetStatus("get-vcs-info")}, 500);
	
	//Send event
	setInterval(function(){ if(commands.length>0) SendEvent(commands.shift());}, 30);
	
};

		  
var UpdateNotification = function(handle,value){ if(handle.hasClass('label-success')) handle.removeClass("label-success"); if(value==1) handle.addClass("label-success") }
var ValidToString = function(value) { return value?"Valid":"Not Valid" } 
var BoolToString = function(value) { return value?"True":"False" } 

class Loading {
	constructor(tag) { this.flag = false, this.count = 5, this.tag = tag, this.noti = true, this.noti_1st = true;  }
	run(opt){
		if(opt<1 && !this.flag) KTApp.block('.'+this.tag, { overlayColor: '#000000', state: 'danger', message: 'Check connection...' }), this.flag = true
		else if(opt>0 && this.flag) KTApp.unblock('.'+this.tag), this.flag = false	
	}
	off(){ KTApp.unblock('.'+this.tag), this.flag = false }
	
	check() { this.count++; }
	received() { this.count=0; }
	iserr() { return this.count>5; }
	iserrlast() { return this.count>0; }
	oprun() { KTApp.blockPage({ overlayColor: '#000', opacity: 0.1, state: 'danger', message: 'Check System'}), this.flag = true }
	opchk() {
		if(this.iserr() && !this.flag)  this.oprun()
		else if(!this.iserrlast() && this.flag)  KTApp.unblock(), this.flag = false
		//console.log(" 1: "+this.count+" 2: "+this.flag+" 3: "+this.iserr()+" 4: "+this.iserrlast())
		this.check()
		return this.iserrlast();
	}
}


var page_rcv_err = 0
let load = new Loading("op");
let load_anta = new Loading("anta");
let load_antb = new Loading("antb");
let load_modem = new Loading("modem");

var check_connectA = false, check_connectB = false, check_connect = false, check_connectModem = false
function ProcRecv(resp){	
	try{ 
		var obj = JSON.parse(resp)
		load.received();
	}
	catch{
		// console.log("[Error] json format is wrong. => "+resp) 
		page_rcv_err++;
		return false;
	}
	
	load.opchk()
	
	try{ if(obj.Id == 'resp-mcu-info'){ } }
	catch{
		// load.oprun()
		// load_anta.off()
		// load_antb.off()
		// load_modem.off()
		return false;
	}
	
	if(obj.Id == 'resp-mcu-info'){ 
	}
	else if(obj.Id == 'resp-anta-info'){ SetAntInfoA(obj.Antenna) }
	else if(obj.Id == 'resp-antb-info'){ SetAntInfoB(obj.Antenna) }
	else if(obj.Id == 'resp-conf' || obj.Id == 'edit-conf'){
		$(".status.conf").html(JSON.stringify(obj,null,2)); 
		//conf.Update(obj)
		// console.log(obj)
		// console.log(obj.System.Vcs.Default.AntSel)
		// console.log(obj.System.Vcs.Default.RefFreq)
		
		var lband = [$('.mnc').find(".lband-mute").find(".selection"),$('.mnc').find(".lband-a").find(".selection"),$('.mnc').find(".lband-b").find(".selection"),$('.mnc').find(".lband-auto").find(".selection")]
		for (var i in lband){ 
			if(lband[i].hasClass('selection-on')) lband[i].removeClass("selection-on")
			if(lband[i].hasClass('selection-auto')) lband[i].removeClass("selection-auto")
			
		}		
		lband[obj.System.Vcs.Default.AntSel].addClass("selection-on")	
		
		var reffrq = [$('.mnc').find(".ref-int").find(".selection"),$('.mnc').find(".ref-ext").find(".selection"),$('.mnc').find(".ref-mod").find(".selection")]
		for (var i in reffrq){ if(reffrq[i].hasClass('selection-on')) reffrq[i].removeClass("selection-on")}		
		reffrq[obj.System.Vcs.Default.RefFreq].addClass("selection-on")	
		
		var sync = [$('.mnc').find(".sync-off").find(".selection"),$('.mnc').find(".sync-on").find(".selection")]
		for (var i in sync){ if(sync[i].hasClass('selection-on')) sync[i].removeClass("selection-on")}		
		sync[obj.System.Vcs.Option.Sync].addClass("selection-on") 

	}
	else if(obj.Id == 'resp-vcs-info'){
		$(".status.vcs").html(JSON.stringify(obj,null,2));
		$(".recv").html("["+Date.now()+"] Receives " +resp.length+"byte of data.");
	
		//Update selection for L-Band.
		var lband = [$('.mnc').find(".lband-mute").find(".selection"),$('.mnc').find(".lband-a").find(".selection"),$('.mnc').find(".lband-b").find(".selection"),$('.mnc').find(".lband-auto").find(".selection")]
		for (var i in lband){ 
			if(lband[i].hasClass('selection-on')) lband[i].removeClass("selection-on")
			if(obj.Vcs.Ant.Sel!=3)if(lband[i].hasClass('selection-auto')) lband[i].removeClass("selection-auto")
		}	
		lband[obj.Vcs.Ant.Sel].addClass("selection-on")	
		if(obj.Vcs.Ant.Auto==1){
			var lband_auto = [$('.mnc').find(".lband-a").find(".selection"),$('.mnc').find(".lband-b").find(".selection")]
			for (var i in lband_auto){ if(lband_auto[i].hasClass('selection-auto')) lband_auto[i].removeClass("selection-auto")}		
			if(obj.Vcs.Ant.AutoA == 1) lband_auto[0].addClass("selection-auto")	
			else if(obj.Vcs.Ant.AutoB == 1) lband_auto[1].addClass("selection-auto")	
		}
		//Update selection for reference freqeuncy.
		var reffrq = [$('.mnc').find(".ref-int").find(".selection"),$('.mnc').find(".ref-ext").find(".selection"),$('.mnc').find(".ref-mod").find(".selection")]
		for (var i in reffrq){ if(reffrq[i].hasClass('selection-on')) reffrq[i].removeClass("selection-on")}		
		reffrq[obj.Vcs.RefFreq.Sel].addClass("selection-on")	
		
		//Update notifies in 'Monitor And Control' block.
		UpdateNotification ($('.mnc').find(".lband-a").find(".noti"), obj.Vcs.Ant.A)
		UpdateNotification ($('.mnc').find(".lband-b").find(".noti"), obj.Vcs.Ant.B)
		UpdateNotification ($('.mnc').find(".lband-auto").find(".noti"), obj.Vcs.Ant.Auto)
		UpdateNotification ($('.mnc').find(".ant-link").find(".noti"), obj.Vcs.Ant.Link)
		UpdateNotification ($('.mnc').find(".modem-lock").find(".noti"), obj.Vcs.Ant.Lock)
		UpdateNotification ($('.mnc').find(".ref-int").find(".noti"), obj.Mcu.Detector.TxInt)
		UpdateNotification ($('.mnc').find(".ref-ext").find(".noti"), obj.Mcu.Detector.TxExt) 
		UpdateNotification ($('.mnc').find(".ref-mod").find(".noti"), obj.Mcu.Detector.TxModem)
		UpdateNotification ($('.mnc').find(".refout").find(".noti"), obj.Mcu.Detector.TxRefFreq)
		
		//Update connection status of devices.
		load_anta.run(obj.Vcs.Ant.SourceA)
		load_antb.run(obj.Vcs.Ant.SourceB)
		load_modem.run(obj.Modem.Connection)
		
		//Update 
		var gpssrc= obj.Gps.UseRmcIdx>obj.Gps.UseGgaIdx?obj.Gps.UseRmcIdx:obj.Gps.UseGgaIdx;
		// - Status block
		$('.status').find(".gps-source").html((obj.Gps.Valid == 1? AntDef.GpsStatus[2] : AntDef.GpsStatus[1])+' / '+AntDef.GpsSource[gpssrc])
		$('.status').find(".gps").html(obj.Gps.Lat+' / '+obj.Gps.Lon)
		$('.status').find(".gyro").html(obj.Gyro.Valid?obj.Gyro.Heading.toString():'-')
		$('.status').find(".gyro-source").html(AntDef.GyroStatus[obj.Gyro.Valid]+' / '+AntDef.GyroSource[obj.Gyro.Source])
		$('.status').find(".block").html(BoolToString(obj.BlockControl.IsBlock)) 
		$('.status').find(".temp").html(obj.Device.Temperature+'&deg')
		// - Show antenna interface type.
		$('.anta').find(".info").html(AntDef.AntConnectType[obj.Vcs.Ant.SourceA])
		$('.antb').find(".info").html(AntDef.AntConnectType[obj.Vcs.Ant.SourceB])
		
		$('.modem').find(".class").html(AntDef.ModemClass[obj.Modem.Class])
		$('.modem').find(".status").html(AntDef.Connection[obj.Modem.Connection])
		$('.modem').find(".lon").html(obj.Modem.Message.Position)
		$('.modem').find(".tf").html(obj.Modem.Message.TpFreq)
		$('.modem').find(".bp").html(obj.Modem.Message.TpSymb)
		$('.modem').find(".rcv").html(obj.Modem.Message.UTC +" / "+ obj.Modem.Message.RcvCnt)
		
		
		//Gyro StepSync Flag
		if(obj.GyroSyncStepStartupFlag)  $('#antif-update').modal('show')
		else $('#antif-update').modal('hide')
		
	}
	else if(obj.Id == 'resp-mcu'){
		
		var sync = [$('.mnc').find(".sync-off").find(".selection"),$('.mnc').find(".sync-on").find(".selection")]
		for (var i in sync){ if(sync[i].hasClass('selection-on')) sync[i].removeClass("selection-on")}		
		sync[obj.System.Vcs.Option.Sync].addClass("selection-on")	
	}
	else if(obj.Id == 'reload-conf'){conf.Update(obj)}
	else if(obj.Id == 'save-conf'){}
	
	try{ 
		if(obj.Id =="resp-vcs-info" && obj.Event.length > 0){ _updatelog(obj.Event) } 
	}
	catch{ return true; }
	
	return true;
}



var kChart = {
	A: null,
	B: null,
	AntA: {NimAgc:[{data:[]}],NimQty:[{data:[]}],Rssd:[{data:[]}],RssdCn:[{data:[]}]}, 
	AntB: {NimAgc:[{data:[]}],NimQty:[{data:[]}],Rssd:[{data:[]}],RssdCn:[{data:[]}]},
	IsEmpty: function(ant){ ant.NimAgc[0].data.length > 5 ? false : true },
	InitData: function(dat){
		var tmp = this.AntA
		for(i=0;i<120;i++) {
			tmp.NimAgc[0].data.push({x:i, y:parseInt(dat.NimAgc.Value)});
			tmp.NimQty[0].data.push({x:i, y:parseInt(dat.NimQuality.Value)});
			tmp.Rssd[0].data.push({x:i, y:parseInt(dat.Rssd.Value)});
			tmp.RssdCn[0].data.push({x:i, y:parseInt(dat.RssdCn.Value)});
		}
		return tmp;
	},
	Option: function(title,avg,max,color){
		return {
			chart: {
				id: 'chart-strip', type: 'area', height: 150,
				toolbar: { show: false },
				animations:{ enabled:true, dynamicAnimation: { enabled: false, speed: 500 } }
			},
			series: [{data:[]}],
			colors: [color],
			xaxis: { axisBorder: { show: false }, axisTicks: { show: false }, labels: { show: false } ,},
			yaxis: { axisBorder: { show: false }, axisTicks: { show: false }, labels: { show: false } },
			stroke: { curve: 'smooth', width: 2.5, },
			dataLabels: { enabled: false, },
			fill: { type: 'gradient',  opacity: 1, 
				gradient: { type: "vertical", shadeIntensity: 0.55, gradientToColors: undefined, inverseColors: true, opacityFrom: 1,
						opacityTo: 0.1, stops: [5, 10, 100], colorStops: [] } },
			grid: { strokeDashArray: 4,  yaxis: { lines: { show: false }  },  },
			annotations: { 
				strokeDashArray: 4,
				opacity: 0.2,
				yaxis: [
					{ y:avg, borderColor: color, label: { borderColor: color+'40', style: { color: '#444', background: color+'40', }, text: 'AVG  '+avg.toString(),}},
					{ y:max, borderColor: color, label: { borderColor: color+'40', style: { color: '#444', background: color+'40', }, text: 'MAX  '+max.toString(),}},
				]},
			title: {
				text: title, align: 'center', margin: 10, offsetX: 0, offsetY: 0, floating: false,
				style: { fontSize:  '13px', fontWeight:  'light', color: color
				},
			}
		}
	},
	OptA: function(title,avg,max){ return this.Option(title,avg,max,'#1bc5bd')},
	OptB: function(title,avg,max){ return this.Option(title,avg,max,'#6993ff')}, 
}

var DrawStripChart = function(id,opt){
	var chart = new ApexCharts(document.querySelector("#"+id), opt);
	chart.render();
	return chart;
}



function SetGyro(){ 
	var obj = {Id: "edit-conf",Group:"Gyro", Data:{},msg:'Applied the gyro setting.'}
	conf.edit.System.Gyro.Type = $('.gyro').find(".type").val();
	conf.edit.System.Gyro.ManualType = $('.gyro').find(".custom-type").val();
	conf.edit.System.Gyro.BaudrateNmea0183 = GetIndexToBaudrate($('.gyro').find(".nmea0183-baudrate").val());
	conf.edit.System.Gyro.BaudrateSyncStep = GetIndexToBaudrate($('.gyro').find(".custom-baudrate").val());
	conf.edit.System.Gyro.Direction =$('.gyro').find(".dir").val();
	conf.edit.System.Gyro.SyncFreq = $('.gyro').find(".sync").val();
	conf.edit.System.Gyro.Converter = parseFloat($('.gyro').find(".converter").val());
	conf.edit.System.Gyro.UserInput = parseFloat($('.gyro').find(".user-input").val());
	obj.Data = conf.edit.System.Gyro;
	AddEventObject(obj)
	console.log(JSON.stringify(obj, null, 2))
}

function SetAntInfo(name,type,dat,idx,cdata){
	// if(kChart.IsEmpty(cdata)) cdata = kChart.InitData(dat)
	
	var title = name+', ';
	var sch = 0, trk = 0
	if(dat.SearchingType.Value !=5){ sch = dat.SearchingType.Value, trk = dat.TrackingType.Value }
	else{ sch = dat.ExternalSearchingType.Value, trk = dat.ExternalTrackingType.Value, title += '[EXT] ' }
	title += AntDef.DrivingStatus[dat.DrivingStatus.Value]+' - ';
	if(dat.DrivingStatus.Value!=3) title += AntDef.SchType[sch];
	else title += AntDef.TrkType[trk];
	
	cdata.NimAgc[0].data.push({x:idx, y:parseInt(dat.NimAgc.Value)});
	cdata.NimQty[0].data.push({x:idx, y:parseInt(dat.NimQuality.Value)});
	cdata.Rssd[0].data.push({x:idx, y:parseInt(dat.Rssd.Value)});
	cdata.RssdCn[0].data.push({x:idx, y:parseInt(dat.RssdCn.Value)});
	if(cdata.NimAgc[0].data.length > 120)cdata.NimAgc[0].data.shift(),cdata.NimQty[0].data.shift(),cdata.Rssd[0].data.shift(),cdata.RssdCn[0].data.shift();
	// console.log("sch:"+dat.SearchingType.Value+","+"trk:"+dat.TrackingType.Value+","+"esch:"+dat.SearchingType.Value+","+"etrk:"+dat.SearchingType.Value+",");
	var tmp = null;
	if(dat.DrivingStatus.Value!=3){
		if(sch==1) tmp = cdata.NimQty
		else if(sch==3) tmp = cdata.Rssd
		else if(sch==4) tmp = cdata.RssdCn	
		else tmp = cdata.NimAgc
	}else{
		if(trk==1) tmp = cdata.NimQty
		else if(trk==2) tmp = cdata.Rssd
		else if(trk==3) tmp = cdata.RssdCn
		else tmp = cdata.NimAgc
	}
	 
	var avg = 0, max = 0;
	for(var i=0;i<tmp[0].data.length;i++){ 
		avg += tmp[0].data[i].y
		if(max < tmp[0].data[i].y) max = tmp[0].data[i].y;
	}
	
	return { title:title, cdata: cdata, active:tmp, max:max, avg:parseInt(avg/tmp[0].data.length)}
}

function FillAntData(type,dat){	
	$('.'+type).find('.lock').html(AntDef.Lock[dat.NimLock.Value] +' / '+ AntDef.Lock[parseInt(dat.ModemLock.Value)])
	$('.'+type).find('.opstep').html(AntDef.DrivingStatus[dat.DrivingStatus.Value])
	$('.'+type).find('.opmode').html(AntDef.DrivingMode[dat.DrivingMode.Value])
	$('.'+type).find('.static').html(AntDef.OnOff[dat.Static.Value])
	$('.'+type).find('.axipass').html(AntDef.OnOff[dat.AsiPass.Value])
	$('.'+type).find('.gyromode').html(AntDef.GyroMode[dat.GyroMode.Value])
	$('.'+type).find('.skewmode').html(AntDef.SkewMode[dat.SkewMode.Value])
	var schidx = dat.ExternalSearchingType.Value;
	var tmp = AntDef.SchType[schidx] ;
	if(schidx==0||schidx==1||schidx==3||schidx==4)
		tmp += ' ('+dat.ExternalLockThreshold.Value+')'
	$('.'+type).find('.extschtype').html(tmp)
	// $('.antb').find('.extschthd').html(dat.DrivingStatus.Value)
	$('.'+type).find('.exttrktype').html(AntDef.TrkType[dat.ExternalTrackingType.Value])

	$('.'+type).find('.nimval').html(dat.NimAgc.Value +' / '+dat.NimQuality.Value)
	$('.'+type).find('.rssdval').html(dat.Rssd.Value +' / '+dat.RssdCn.Value)

	$('.'+type).find('.heading').html(dat.Heading.Value+'&deg')
	$('.'+type).find('.elevation').html(dat.Elevation.Value+'&deg')
	$('.'+type).find('.azimuth').html(dat.Azimuth.Value+'&deg')
	$('.'+type).find('.skew').html(dat.Skew.Value+'&deg')

	$('.'+type).find('.sat-id').html(dat.SatNum.Value)
	$('.'+type).find('.sat-name').html(dat.SatName.Value)
	$('.'+type).find('.sat-lon').html(dat.SatLon.Value+'&deg')
	$('.'+type).find('.band').html(AntDef.Band[dat.RxBand.Value])
	$('.'+type).find('.polarity').html(AntDef.Polarity[dat.RxPolarity.Value])
	$('.'+type).find('.schtype').html(AntDef.SchType[dat.SearchingType.Value])
	$('.'+type).find('.trktype').html(AntDef.TrkType[dat.TrackingType.Value])

	$('.'+type).find('.gps-status').html(AntDef.GpsStatus[dat.GpsStatus.Value])
	$('.'+type).find('.gps-lon').html(dat.Latitude.Value)
	$('.'+type).find('.gps-lat').html(dat.Longitude.Value)
	$('.'+type).find('.gps-info').html(dat.GpsSpeed.Value +'m&middot;s / '+dat.GpsTrackAngle.Value+'&deg')

	$('.'+type).find('.temprature').html(dat.Temperature.Value+'&deg')
	$('.'+type).find('.code').html(dat.FunctionCode.Value +' / '+dat.ErrorCode.Value)
	
	
	$('.'+type).find('.offset0').html(dat.SyncOffset0.Value +'&deg')
	$('.'+type).find('.offset1').html(dat.SyncOffset1.Value +'&deg')
	$('.'+type).find('.offset2').html(dat.SyncOffset2.Value +'&deg')
}


var anta_rx_idx = 100, antb_rx_idx = 100;;
function SetAntInfoA(dat){
	var type = 'anta';
	var c = SetAntInfo('Antenna A',type,dat,anta_rx_idx++,kChart.AntA)
	kChart.AntA = c.cdata;	
	kChart.A.updateOptions(kChart.OptA(c.title,c.avg, c.max))
	kChart.A.updateSeries(c.active)
	FillAntData(type,dat)
}
function SetAntInfoB(dat){
	var type = 'antb';
	var c = SetAntInfo('Antenna B',type,dat,antb_rx_idx++,kChart.AntB)
	kChart.AntB = c.cdata;	
	kChart.B.updateOptions(kChart.OptB(c.title,c.avg, c.max))
	kChart.B.updateSeries(c.active)
	FillAntData(type,dat)
}
