/*"use strict";
	[KNS Inc] hhwang, 20201206 
	0.001 Create
	0.015 Define all functions
	0.100 refactoring
	0.101 add modal, at gyro setting first
*/

var conf = {
	obj:null,
	edit:null,
	RloadConf: function (){ AddEventCommand("reload-conf"); },
	SaveConf: function (){ AddEventCommand("save-conf");},
	UpdateGyro: function (obj){		
		var Gyro = obj.System.Gyro
		$('.gyro').find(".type").val(Gyro.Type);
		$('.gyro').find(".custom-type").val(Gyro.ManualType);
		$('.gyro').find(".nmea0183-baudrate").val(GetBaudrateToIndex(Gyro.BaudrateNmea0183));
		$('.gyro').find(".custom-baudrate").val(GetBaudrateToIndex(Gyro.BaudrateSyncStep));
		$('.gyro').find(".dir").val(Gyro.Direction);
		$('.gyro').find(".sync").val(Gyro.SyncFreq);
		$('.gyro').find(".converter").val(Gyro.Converter)
		$('.gyro').find(".user-input").val(Gyro.UserInput)
	},
	UpdateGps: function (obj){	
		var Interface = obj.System.Interface	
		$('.gps').find(".nmea-format").val(Interface.Nmea.Format);
		$('.gps').find(".nmea-baudrate").val(GetBaudrateToIndex(Interface.Nmea.Baudrate));
		$('.gps').find(".console-format").val(Interface.Console.Format);
		$('.gps').find(".console-baudrate").val(GetBaudrateToIndex(Interface.Console.Baudrate));
	},
	UpdateAbsp: function (obj){
		var Absp = obj.System.Absp		
		$('.absp').find(".use").val(Absp.IsUsing);
		$('.absp').find(".class").val(Absp.ClassType)
		$('.absp').find(".band1").val(Absp.LnbBand1Lo)
		$('.absp').find(".band2").val(Absp.LnbBand2Lo)
		$('.absp').find(".band3").val(Absp.LnbBand3Lo)
		$('.absp').find(".band4").val(Absp.LnbBand4Lo)
		$('.absp').find(".rolloff").val(Absp.RollOff)
		$('.absp').find(".rfterm").val(Absp.RfTermType)
		$('.absp').find(".extlocksrc").val(Absp.ExtLockSrcType)
		$('.absp').find(".ttl").val(Absp.ConsolOutputType)
	},
	UpdateInterface: function (obj){
		var Interface = obj.System.Interface
		$('.antif').find(".anta-ip").val(Interface.AntA.IP)
		$('.antif').find(".anta-port").val(Interface.AntA.Port)
		$('.antif').find(".antb-ip").val(Interface.AntB.IP)
		$('.antif').find(".antb-port").val(Interface.AntB.Port)
	},
	UpdateNetwork: function (obj){
		var Network = obj.Network
		var Ports = obj.System.Interface.Ports
		$('.network').find(".ip").val(Network.Addr)
		$('.network').find(".mask").val(Network.Netmask)
		$('.network').find(".gw").val(Network.Gateway)
		$('.network').find(".abs").val(Ports.Abs)
		$('.network').find(".mac").val(Network.Mac)
	},
	UpdateVcs: function (obj){
		var Vcs = obj.System.Vcs.Default
		var VcsOpt = obj.System.Vcs.Option
		this.obj.Vcs = Vcs, this.edit.Vcs  = Vcs 
		$('.ant-sel').html(' ('+Vcs.AntSel+')')
		$('.ref-freq').html(' ('+Vcs.RefFreq+')')
		$('.ref-sync').html(' ('+VcsOpt.Sync+')')
		$('.attn0').val(Vcs.AttnRx1)
		$('.attn1').val(Vcs.AttnRx2)
		$('.attn2').val(Vcs.AttnTx1)
		$('.attn3').val(Vcs.AttnTx2)
	},
	UpdateAttn: function (obj){
		var Vcs = obj.System.Vcs.Default
		this.obj.Vcs = Vcs, this.edit.Vcs  = Vcs 
		$('.attn').find(".rxa").find(".dat").val(Vcs.AttnRx1)
		$('.attn').find(".rxb").find(".dat").val(Vcs.AttnRx2)
		$('.attn').find(".txa").find(".dat").val(Vcs.AttnTx1)
		$('.attn').find(".txb").find(".dat").val(Vcs.AttnTx2) 
	},
	Update: function (obj){ 
		this.obj = obj, this.edit = obj 
		this.UpdateGyro(obj)
		this.UpdateGps(obj)
		this.UpdateAbsp(obj)
		this.UpdateInterface(obj)
		this.UpdateNetwork(obj)
		this.UpdateGpsManipulation(obj)
		this.UpdateAttn(obj)
		//this.UpdateOutputFormat(obj)
		//this.UpdateVcs(obj)
	},
	SetGyro: function (){ 
		var obj = {Id: "edit-conf",Group:"Gyro", Data:{},msg:'Applied the gyro setting.'}
		conf.edit.System.Gyro.Type = $('.gyro').find(".type").val();
		conf.edit.System.Gyro.ManualType = $('.gyro').find(".custom-type").val();
		conf.edit.System.Gyro.BaudrateNmea0183 = GetIndexToBaudrate($('.gyro').find(".nmea0183-baudrate").val());
		conf.edit.System.Gyro.BaudrateSyncStep = GetIndexToBaudrate($('.gyro').find(".custom-baudrate").val());
		conf.edit.System.Gyro.Direction =$('.gyro').find(".dir").val();
		conf.edit.System.Gyro.SyncFreq = $('.gyro').find(".sync").val();
		conf.edit.System.Gyro.Converter = parseFloat($('.gyro').find(".converter").val());
		conf.edit.System.Gyro.UserInput = parseFloat($('.gyro').find(".user-input").val());
		obj.Data = conf.edit.System.Gyro;
		AddEventObject(obj)
		console.log(JSON.stringify(obj, null, 2))
	},
	SetGps: function (){ 
		console.log(conf.edit)
		var obj = {Id: "edit-conf",Group:"Gps", Data:{Nmea:{},Console:{}},msg:'Applied the GPS setting.' }
		conf.edit.System.Interface.Nmea.Format = ($('.gps').find(".nmea-format").val());
		conf.edit.System.Interface.Nmea.Baudrate = GetIndexToBaudrate($('.gps').find(".nmea-baudrate").val());
		conf.edit.System.Interface.Console.Format = ($('.gps').find(".console-format").val());
		conf.edit.System.Interface.Console.Baudrate = GetIndexToBaudrate($('.gps').find(".console-baudrate").val());
		obj.Data.Nmea = conf.edit.System.Interface.Nmea
		obj.Data.Console = conf.edit.System.Interface.Console
		AddEventObject(obj) 
		console.log(JSON.stringify(obj, null, 2))
	},
	SetAbsp: function (){ 
		var obj = {Id: "edit-conf",Group:"Absp", Data:{},msg:'Applied the ABSP setting.' }
		conf.edit.System.Absp.IsUsing = parseInt($('.absp').find(".use").val());
		conf.edit.System.Absp.ClassType = parseInt($('.absp').find(".class").val());
		conf.edit.System.Absp.LnbBand1Lo = parseInt($('.absp').find(".band1").val());
		conf.edit.System.Absp.LnbBand2Lo = parseInt($('.absp').find(".band2").val());
		conf.edit.System.Absp.LnbBand3Lo = parseInt($('.absp').find(".band3").val());
		conf.edit.System.Absp.LnbBand4Lo = parseInt($('.absp').find(".band4").val());
		conf.edit.System.Absp.RollOff = parseFloat($('.absp').find(".rolloff").val());
		conf.edit.System.Absp.RfTermType = parseInt($('.absp').find(".rfterm").val());
		conf.edit.System.Absp.ExtLockSrcType = parseInt($('.absp').find(".extlocksrc").val());
		conf.edit.System.Absp.ConsolOutputType = parseInt($('.absp').find(".ttl").val());
		obj.Data = conf.edit.System.Absp;
		AddEventObject(obj)
		console.log(JSON.stringify(obj, null, 2))
	},
	SetAntif: function (){ 
		var obj = {Id: "edit-conf",Group:"Antif", Data:{AntA:{},AntB:{}},msg:'Applied the antenna interface setting.' }

		conf.edit.System.Interface.AntA.IP = ($('.antif').find(".anta-ip").val());
		conf.edit.System.Interface.AntA.Port = ($('.antif').find(".anta-port").val());
		conf.edit.System.Interface.AntB.IP = ($('.antif').find(".antb-ip").val());
		conf.edit.System.Interface.AntB.Port = ($('.antif').find(".antb-port").val());
		obj.Data.AntA = conf.edit.System.Interface.AntA
		obj.Data.AntB = conf.edit.System.Interface.AntB
		AddEventObject(obj)
		//console.log(JSON.stringify(obj, null, 2))
	},
	SetNetwork: function (){ 
		var obj = {Id: "edit-conf",Group:"Network", Data:{ 
			Network: {
			Addr: $('.network').find(".ip").val(),
			Netmask: $('.network').find(".mask").val(),
			Gateway: $('.network').find(".gw").val(),
			Mac: $('.network').find(".mac").val(),
		  },
			Ports:{
				"Abs": parseInt($('.network').find(".abs").val()),
				"Mnc": 0
			  },
		},msg:'Applied the VCS network setting.' }
		AddEventObject(obj)
		//console.log(JSON.stringify(obj, null, 2))
	},
	SetAntSel: function (idx){ commands.push({Id:"set-mcu-ant",value:idx}); },
	SetFreqSel: function (idx){ commands.push({Id:"set-mcu-freq",value:idx}); },
	SetAttnVal: function (idx, type){	
		var list = [$('.attn').find(".rxa"),$('.attn').find(".rxb"),$('.attn').find(".txa"),$('.attn').find(".txb")]
		var data = parseFloat(list[idx].find(".dat").val())
		if(type==1) if(data<=31) data += 0.25;
		if(type==3) if(data>=0.25) data -= 0.25;
		list[idx].find(".dat").val(data)
		this.SetAttn(idx)
	},
	SetAttn: function (idx){
		var list_name = ['RX-A','RX-B','TX-A','TX-B']
		var list = [$('.attn').find(".rxa"),$('.attn').find(".rxb"),$('.attn').find(".txa"),$('.attn').find(".txb")]
		var data = parseFloat(list[idx].find(".dat").val())
		//Check min & max
		if(data<0) data = 0; else if (data>31.25) data = 31.25;		
		//Trim
		data = data * 100;
		tmp = (data-(data % 25)) /100;
		list[idx].find(".dat").val(tmp)
		commands.push({Id:"set-mcu-attn",target:idx, value: tmp, msg:'Applied the attenuator setting.('+list_name[idx]+')' });	
	},
	SetSyncMode: function (idx){ commands.push({Id:"set-mcu-sync",value:idx}); },
	SetGyroUser: function (){ 
		var obj = {Id: "edit-conf",Group:"GyroUserHeading", Data:{} }
		obj.Data = parseFloat($('.gyro').find(".user").find(".input:eq(0)").val())
		AddEventObject(obj)
		//console.log(JSON.stringify(obj, null, 2))
	},
	
	
	UpdateGpsManipulation: function (obj){ 
		var GpsManipulation = obj.GpsManipulation
		$('.fake').find(".use").val(GpsManipulation.IsUsing);
		$('.fake').find(".lat").val(GpsManipulation.Latitude)
		$('.fake').find(".lon").val(GpsManipulation.Longitude)
	},
	SetGpsManipulation: function (){ 
		var obj = {Id: "set-fake", Data:{ 
			Use:$('.fake').find(".use").val(), 
			Lat:$('.fake').find(".lat").val(),
			Lon:$('.fake').find(".lon").val() 
			},
			msg:'Applied the position manipulation setting.' 
		}
		AddEventObject(obj)
		//console.log(JSON.stringify(obj, null, 2))
	},
} 

var reboot_flag = false; 
window.onload = function() {	
	$('.gyro').find(".apply").click(function(){ conf.SetGyro()});
	// $('.gyro').find(".apply").click(function(){ $('#exampleModal').modal('show')});
	$('.gps').find(".apply").click(function(){ conf.SetGps()});
	$('.absp').find(".apply").click(function(){ conf.SetAbsp()});
	// $('.antif').find(".apply").click(function(){ conf.SetAntif()});
	$('.antif').find(".apply").click(function(){ conf.SetAntif(),$('#antif-update').modal('hide'),StopCheckConnection(),setTimeout("location.reload()", 30000)});
	$('.antif').find(".reboot").click(function(){ 
		var flag = false;
		var chkmsg = "";
		chkmsg += "Change List" 
		chkmsg += "<ul>"
		if(conf.edit.System.Interface.AntA.IP != ($('.antif').find(".anta-ip").val())) chkmsg += "<li>Antenna A, IP Address</li>", flag = true
		if(conf.edit.System.Interface.AntA.Port != ($('.antif').find(".anta-port").val()) ) chkmsg += "<li>Antenna A, Port</li>", flag = true
		if(conf.edit.System.Interface.AntB.IP != ($('.antif').find(".antb-ip").val())) chkmsg += "<li>Antenna B, IP Address</li>", flag = true
		if(conf.edit.System.Interface.AntB.Port != ($('.antif').find(".antb-port").val())) chkmsg += "<li>Antenna B, Port</li>", flag = true
		chkmsg += "</ul>"
		if(!flag) chkmsg = "No Change"
		$('.antif').find(".modal-body").find(".info0").html(chkmsg)

		$('#antif-update').modal('show')
		});
	$('.network').find(".apply").click(function(){ conf.SetNetwork(),$('#network-update').modal('hide'),StopCheckConnection(),setTimeout("location.reload()", 30000)});
	$('.network').find(".reboot").click(function(){ 
		var flag = false;
		var chkmsg = "";
		chkmsg += "Change List"
		chkmsg += "<ul>"
		if(conf.edit.Network.Addr != ($('.network').find(".ip").val())) chkmsg += "<li>IP Address</li>", flag = true
		if(conf.edit.Network.Netmask != ($('.network').find(".mask").val())) chkmsg += "<li>Netmask</li>", flag = true
		if(conf.edit.Network.Gateway != ($('.network').find(".gw").val())) chkmsg += "<li>Gateway</li>", flag = true
		if(conf.edit.System.Interface.Ports.Abs != ($('.network').find(".abs").val())) chkmsg += "<li>Port</li>", flag = true
		if(conf.edit.Network.Mac != ($('.network').find(".mac").val())) chkmsg += "<li>MAC Address</li>", flag = true
		chkmsg += "</ul>"
		if(!flag) chkmsg = "No Change"
		$('.network').find(".modal-body").find(".info0").html(chkmsg)
		//console.log(conf.edit.System.Interface.Ports.Abs +","+ $('.network').find(".abs").val())
		
		$('#network-update').modal('show')
		});
	$('.fake').find(".apply").click(function(){ conf.SetGpsManipulation()});
	$('.attn').find(".rxa").find(".pluse").click(function(){ conf.SetAttnVal(0,1)});
	$('.attn').find(".rxa").find(".minus").click(function(){ conf.SetAttnVal(0,3)});
	$('.attn').find(".rxa").find(".set").click(function(){ conf.SetAttnVal(0,0)});
	$('.attn').find(".rxb").find(".pluse").click(function(){ conf.SetAttnVal(1,1)});
	$('.attn').find(".rxb").find(".minus").click(function(){ conf.SetAttnVal(1,3)});
	$('.attn').find(".rxb").find(".set").click(function(){ conf.SetAttnVal(1,0)});
	$('.attn').find(".txa").find(".pluse").click(function(){ conf.SetAttnVal(2,1)});
	$('.attn').find(".txa").find(".minus").click(function(){ conf.SetAttnVal(2,3)});
	$('.attn').find(".txa").find(".set").click(function(){ conf.SetAttnVal(2,0)});
	$('.attn').find(".txb").find(".pluse").click(function(){ conf.SetAttnVal(3,1)});
	$('.attn').find(".txb").find(".minus").click(function(){ conf.SetAttnVal(3,3)});
	$('.attn').find(".txb").find(".set").click(function(){ conf.SetAttnVal(3,0)});
	$('.attn').find(".ref-set").click(function(){ 
		var idx = parseInt($('.attn').find(".ref").val())
		
		if ( idx == 0 )commands.push({Id:"set-mcu-freqmnl",target:idx, value0:0, value1:0, value2:0}); 
		else if ( idx == 1)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:0, value1:0, value2:1}); 
		else if ( idx == 2)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:0, value1:1, value2:0}); 
		else if ( idx == 3)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:0, value1:1, value2:1}); 
		else if ( idx == 4)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:1, value1:0, value2:0}); 
		else if ( idx == 5)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:1, value1:0, value2:1}); 
		else if ( idx == 6)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:1, value1:1, value2:0}); 
		else if ( idx == 7)commands.push({Id:"set-mcu-freqmnl",target:idx, value0:1, value1:1, value2:1}); 

	}); 	 
	$('.reload').click(function(){ GetStatus("reload-conf");});
	 
	$('.gyro').find(".nmea0183").hide()
	$('.gyro').find(".custom").hide()
	$('.gyro').find(".user").hide()

	GetStatus("get-conf");
	
	//Send event
	setInterval(function() { SendEvent({Id:"get-vcs-info"})}, 500);
	// setInterval(function() { if(!reboot_flag) SendEvent({Id:"get-vcs-info"})}, 500);
	setInterval(function(){ if(commands.length>0) SendEvent(commands.shift());}, 30);
	
	setInterval(function(){ 
		if($('.gyro').find(".type").val()==1){$('.gyro').find(".nmea0183").show() } else{ $('.gyro').find(".nmea0183").hide()}
		if($('.gyro').find(".type").val()==2){$('.gyro').find(".custom").show() } else{ $('.gyro').find(".custom").hide()}
		if($('.gyro').find(".type").val()==4){$('.gyro').find(".user").show() } else{ $('.gyro').find(".user").hide()}
	}, 250);
	
	
	
};
 
 
function ProcRecv(resp){	
	try{ var obj = JSON.parse(resp);}
	catch{
		console.log("[Error] json format is wrong. => "+resp);
		return;
	}
	
	try{ if(obj.Id == 'resp-vcs-info'){ } }
	catch{
		// load.oprun()
		// load_anta.off()
		// load_antb.off()
		// load_modem.off()
		return false;
	}
	// reboot_flag
	if(obj.Id == 'resp-mcu-info'){ }
	else if(obj.Id == 'resp-anta-info'){ SetAntInfoA(obj.Antenna) }
	else if(obj.Id == 'resp-antb-info'){ SetAntInfoB(obj.Antenna) }
	else if(obj.Id == 'resp-conf'){ conf.Update(obj) }
	else if(obj.Id == 'edit-conf' ){ conf.Update(obj) }
	else if(obj.Id == 'resp-vcs-info'){
		//Gyro StepSync Flag
		if(obj.GyroSyncStepStartupFlag) window.location.replace('index.html')
	}
	else if(obj.Id == 'resp-mcu'){ }
	else if(obj.Id == 'resp-fake'){ }
	else if(obj.Id == 'reload-conf'){conf.Update(obj), __noti_with_date(0,"Reloaded setting information.")}
	else if(obj.Id == 'save-conf'){}
	
	try{  if(obj.Id =="resp-vcs-info" && obj.Event.length > 0){ _updatelog(obj.Event) }  }
	catch{ return true; }
	
	return true; 
}

var GetBaudrateToIndex = function(val){
	var list = AntDef.Baudrate; // [4800,9600,19200,38400,57600,115200], defined in vcs.js
	for(var i in list) if(val==list[i]) return i
	return 0
}
var GetIndexToBaudrate = function(val){
	var list = AntDef.Baudrate; // [4800,9600,19200,38400,57600,115200], defined in vcs.js
	if(val>=list.length) return list[0]
	return list[val]
}

