"use strict";
/* 	
	[KNS Inc] hhwang, 20201206 
	0.001 Create
	0.023 lband events 
	0.100 refactoring
*/  

var AntDef = { 
	OnOff:['Off','On'],
	Lock:['Unlock','Locked'],
	DrivingStatus:["Standby", "Initial", "Search", "Track", "Search Fail", "Axis Ctrl", "Demo Operation", "Unwrap", "Axis Calibration"],
	DrivingMode:["Standby Mode", "Manual Point", "Manual Search", "Auto Search", "Axis Ctrl", "Demonstration", "Axis Calibration"],
	GyroMode:["Normal", "Manual", "Gyro Free"],
	SkewMode:["Automatic", "Manual", "Jog"],
	Band:["C-Band", "X-Band", "KU-Band", "KA-Band"],
	Polarity:["Horizontal", "Vertical", "Left Handed", "Right Handed", "Follow TX-RX Pol"],
	TRxPolarity:["Cross Pol", "Co Pol"],
	SchType:["DVB AGC THD", "DVB C/N THD", "DVB CLOCK", "RSSD THD", "RSSD C/N THD", "EXT LOCK"],
	TrkType:["DVB AGC", "DVB C/N", "RSSD", "RSSD C/N"],
	GpsStatus:["Unknown", "Not Valid", "Valid"],
	GyroStatus:["Not Valid", "Valid", "Manual"],
	GyroSource:['Unknown','NMEA2000', 'NMEA0183', 'Step&Sync', 'External', 'User', 'Auto'],
	GpsSource:['Unknown','Ext-GyroPort', 'Ext-NmeaPort', 'Ext-ConsolePort', 'Antenna A', 'Antenna B', 'Ant A Burst', 'Ant B Burst'],
	AntConnectType:['Unknown','TCP', 'Serial'],
	ModemClass:['iDirect','ComROAM', 'STMVACP'],
	Connection:['Not Connection', 'Connected'],
	Baudrate:[4800,9600,19200,38400,57600,115200],
} 


var log_dt = ''
var log = null
function _updatelog(obj){
	if(log_dt== '' || (log_dt < obj[obj.length-1].dt)){
		if(log_dt!= '') _notify(obj[obj.length-1]) 
		_update_side_log(obj)
	}
}

function _update_side_log(obj){
	//<div class="bg-primary py-2 px-4 block"><font class="dt">2021-01-01 17:12:23.231</font><hr class='split'><font class="msg">Antenna is disconneted.</font></div>
	var tmp = ''
	var tmp_system = ''
	var tmp_setting = ''
	for(var v in obj){
		var msg = obj[v].desc+(obj[v].data.length>1?(" "+obj[v].data):"")+"."
		tmp = '<div class="bg-'+noti_types[obj[v].type]+' py-2 px-2 block"><font class="dt">'+obj[v].dt+'</font><hr class="split"><font class="msg">'+msg+'</font></div>' +tmp;
		if(obj[v].name == 'system') tmp_system = '<div class="bg-'+noti_types[obj[v].type]+' py-2 px-2 block"><font class="dt">'+obj[v].dt+'</font><hr class="split"><font class="msg">'+msg+'</font></div>' +tmp_system;	
		if(obj[v].name == 'setting') tmp_setting = '<div class="bg-'+noti_types[obj[v].type]+' py-2 px-2 block"><font class="dt">'+obj[v].dt+'</font><hr class="split"><font class="msg">'+msg+'</font></div>' +tmp_setting;		
	}	
	$('.logs').find(".items.all").html(tmp)
	$('.logs').find(".items.system").html(tmp_system)
	$('.logs').find(".items.setting").html(tmp_setting)
	log = obj, log_dt = obj[obj.length-1].dt
}

var noti_types=['primary','success','warning','danger'];
function _notify(obj){
	// console.log(obj)
	// console.log("1 : "+obj.dt)  
	// console.log("2 : "+obj.data.length>1?(" "+obj.data):"")
	__noti(obj.type,obj.dt,obj.desc+(obj.data.length>1?(" "+obj.data):"")+".")
}			 
function __noti_with_date(type,msg){var d = new Date();$(document).ready(function(){$.notify({title:d.getFullYear()+'-'+ (d.getMonth()<9?"0":"")+ (d.getMonth()+1)+'-'+ (d.getDate()<10?"0":"")+d.getDate()+'&nbsp;&nbsp;'+ (d.getHours()<10?"0":"")+d.getHours()+':'+ (d.getMinutes()<10?"0":"")+d.getMinutes()+':'+ (d.getSeconds()<10?"0":"")+d.getSeconds()+".00", message: '- '+msg},{type: noti_types[type],timer: 1000});});}	
function __noti(type,title,msg){$(document).ready(function(){$.notify({title:title, message: msg},{type: noti_types[type],timer: 1000});});}


var _check_connection_ = 0
var _check_connection_flag = true
var _chk_rst_cnt = 0
function StopCheckConnection() {_check_connection_flag = false;_check_connection_=5,$('.load-page').show(), _chk_rst_cnt = 30;SetChkRstWorker()}
function StartCheckConnection() {_check_connection_flag = true}
function ResetCheckConnection() {if(_check_connection_flag)_check_connection_=0}
function SetCheckConnection() {if(_check_connection_flag)_check_connection_++}
function ResetConnection() {ResetCheckConnection(),CheckConnection() }
function SetConnection() {SetCheckConnection(), CheckConnection() }
function IsConnection() {return _check_connection_>2?false:true}
function CheckConnection() { if(IsConnection()){$('.load-page').hide() } else{ $('.load-page').show() } }
function SetChkRstWorker(){
	setInterval(function(){ 
		if(_chk_rst_cnt>0) _chk_rst_cnt--;	
		if(_chk_rst_cnt>0){
			var msg = _chk_rst_cnt+' seconds to restart.'
			$('.load-page').find('.status').html(msg) 
		}
	}, 1000);	
};

var commands = new Array(); 
function GetStatus(cmd) { AddEventCommand(cmd); }
function AddEventCommand(cmd) { if(commands.length<10) commands.push({Id: cmd}); }
function AddEventObject(obj) { if(commands.length<10) commands.push(obj); }
function RloadConf() { AddEventCommand("reload-conf"); } 
function SaveConf() {AddEventCommand("save-conf");}
function SendEventEx(obj,php_parser) 
{
	if(obj == null) return;  
	  
	var strOjb =JSON.stringify(obj);
	var xhp = new XMLHttpRequest();  
	
	//xhp.responseText = "";
	xhp.addEventListener("error", transferFailed);
	xhp.onreadystatechange = function() {  
	if (this.readyState == 4 && this.status == 200) { 
		if(ProcRecv(this.responseText)) ResetConnection()
		else SetConnection()
	}};
	xhp.open("GET", "assets/php/"+php_parser+"?req="+strOjb, true);
	xhp.send();

}
function SendEventForUpdate(obj) { SendEventEx(obj,"request_update.php") }
function SendEvent(obj) { SendEventEx(obj,"request.php") }
function transferFailed(evt){SetConnection()}

// var commands = new Array();
// function GetStatus(cmd) { AddEventCommand(cmd); }
// function AddEventCommand(cmd) { if(commands.length<10) commands.push({Id: cmd}); }
// function AddEventObject(obj) { if(commands.length<10) commands.push(obj); }
// function SendEvent(obj)
// {
	// if(obj == null) return;
	
	// var strOjb =JSON.stringify(obj);
	// var xhp = new XMLHttpRequest();  
	
	// //xhp.responseText = "";
	// xhp.addEventListener("error", transferFailed);
	// xhp.onreadystatechange = function() {  
	// if (this.readyState == 4 && this.status == 200) { 
		// if(ProcRecv(this.responseText)) ResetConnection()
		// else SetConnection()
	// }};
	// xhp.open("GET", "assets/php/request.php?req="+strOjb, true);
	// xhp.send();
// }
// function transferFailed(evt){SetConnection()}


  